!   **********************************************************************
!   Trata o problema de anlise de sries Poisson, com sazonalidade, efpol aleatrio  
!   e variveis regressoras, via Metropolis-Hasting. Movimento componente a componente.
!   O nvel  estimado, porm no evolui no tempo
!   Funo de transferncia com nlag defasagens na regressora
!   Proposta normal para o logito dos parmetros autoregressivos
!   **********************************************************************

	! #####################################################b###
	! #                                                       #
	! #  Este modulo contem todas as variaveis que serao      #
	! #  utilizadas nesta e em outras subrotinas ou funcoes   #
	! #                                                       #
	! #########################################################

      MODULE variables
	IMPLICIT NONE
	SAVE
	DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:) :: 
     +  idmatb,Wt,idmatd,Cdelta,deltasai,betasai,efpolsai,efclimsai
     + ,lambdasai,omegasai,St,idmato,comega
	INTEGER, ALLOCATABLE, DIMENSION(:,:) :: missingW
	DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:)   :: 
     +  Yt,soma,mbeta,betaA,lamb, mmAux,CmAux,probac,efpol,
	+  efclim,mdelta,somaW,deltaA,missing,Xt,bt,
     +	  Cbetasai,ef0sai,rhosai,musai,
	+efsaz,momega ,omegaA


	INTEGER, ALLOCATABLE, DIMENSION(:)   :: 
     +  cont,contW,missy
	CHARACTER*16 dad
	character*12 saida
	DOUBLE PRECISION :: acx0,aCm,acb,acd,rhop,acrp,acrc,acefp,acefc,
     +  postnovo,postvelho,propnovo,propvelho,mut,efpol0,efclim0,rhoc,
	+  mefp,Cefp,mefc,Cefc,psip,psic,x0,mX,Cx,ab1,Rb1,Cbeta,aC, bC,aco


	INTEGER :: nregr,maxmiss,Comp,nexpl,nclim,flagdum,flagsaz,maxmissW
	+      ,totmissy,i,j,k,imiss,imissy,grav,burning,totamost,cadfinal,
     +           jump,iter,status,sem,lixo,totmiss,imissW,totmissw,
	+           rejp,rejc,nlag,nsaz

	REAL,PARAMETER ::PI=3.141592653589793 

	END MODULE variables

	
	   ! #####################################################################
	   ! #
 	   ! #  PROGRAMA PRINCIPAL 
         ! #
 	   ! #####################################################################

	   PROGRAM repar2
	   USE variables
	   IMPLICIT NONE
	   DOUBLE PRECISION ::	w1A
	   	   
	   	write(*,'(1X,A\)') 'nome do arq saida:'
 	    read (*,'(A)') saida
	 
	   print *,"Program repar2..."

	   CALL readdata()
	    call gettim(status,status,status,sem)
          call seed(sem)


	 ! Valores iniciais 

	   ALLOCATE(deltaA(nclim),mmAux(comp)
     +   ,CmAux(comp),probac(comp),efpol(comp),efclim(comp), 
     + deltasai(totamost,nclim), rhosai(totamost),musai(totamost), 
     + Cbetasai(totamost),ef0sai(totamost),
	+betasai((cadfinal/jump),comp),efpolsai((cadfinal/jump),comp),
	+efclimsai((cadfinal/jump),comp),lambdasai((cadfinal/jump),comp),
     +efsaz(comp),omegaA(nsaz),omegasai(totamost,nsaz))


         mut=0.8d0
	   bt=0.0d0
	   deltaA(1)=-0.02d0   
	   deltaA(2)=0.01d0
	   omegaA=0.0d0
	   mmAux=0.0d0
	   CmAux=0.0d0
	   probac=0.0d0
	   efpol=-0.5d0
	   efclim=0.0d0
	   efpol0=0.2d0
	   W1A=100000000.0d0
	   Cbeta=0.00002d0
	   x0=-1.28d0
	   

	   rhop=0.8d0
	   print*,"Certo . . ."

c  **************************************************
	  aCm=0.0d0
	  acb=0.0d0
	  acd=0.0d0
	  acrp=0.0d0
	  acefp=0.0d0
	  acx0=0.0d0
	aco=0.0d0

       !Gera uma corrida do vetor parametrico via Metropolis-Hasting 


    	  open(114,
     +  file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\log.txt'
     +	   ,status='unknown')

       do iter=1,TOTAMOST
	       call Met_Has(comp,betaA,deltaA,omegaA,W1A,lamb)
	if(mod(iter,100).EQ.0)then
       write(*,*) iter
	endif
	           
	       rhosai(iter) =rhop
		   musai(iter)=mut
	       deltasai(iter,:)=deltaA
	       ef0sai(iter)=efpol0
	       Cbetasai(iter)=Cbeta
	       omegasai(iter,:)=omegaA

	if ((iter.GT.(totamost-cadfinal)).AND.(mod(iter,jump).EQ.0)) then
	           betasai((iter-(totamost-cadfinal))/jump,:)=betaA
	           efpolsai((iter-(totamost-cadfinal))/jump,:)=efpol
	           lambdasai((iter-(totamost-cadfinal))/jump,:)=lamb
 !	           efclimsai((iter-(totamost-cadfinal))/jump,:)=efclim
	endif
             
      end do
	 close(unit=114)

	OPEN(10,file=
	+'c:\mariane\doutorado\output\tese\mod4r1s0btszb\la.txt'
     +	   ,status='unknown',access='append')
	OPEN(103,
     +file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\rh.txt'
     +	   ,status='unknown',access='append')			   
      open(105,
     +file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\be.txt'
     +	   ,status='unknown',access='append')
    	open(107,
     +file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\mu.txt'
     +	   ,status='unknown',access='append')
	open(108,
     +file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\efp.txt'
     +	   ,status='unknown',access='append')
 	open(109,
     +file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\ac.txt'
     +	   ,status='unknown')
	open(110,
     +file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\de.txt'
     +	   ,status='unknown',access='append')

!	open(111,file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\efc.txt'
!     +	   ,status='unknown')

	open(112,
     +file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\ef0.txt'
     +	   ,status='unknown',access='append')

  	open(113,
     +file='c:\mariane\doutorado\output\tese\mod4r1s0btszb\Cb.txt'
     +	   ,status='unknown',access='append')
   	open(116,file=
     +'c:\mariane\doutorado\output\tese\mod4r1s0btszb\om.txt'
     +	   ,status='unknown',access='append')





      do iter=1,TOTAMOST
	write(*,*) 'grav: ',iter
	 write (103,*) rhosai(iter)
	 write (107,*) musai(iter)
	 write(110,*) deltasai(iter,:)
	 write(112,*) ef0sai(iter)
	 write(113,*) Cbetasai(iter)
	 write(116,*) omegasai(iter,:)

	 if ((iter.GT.(totamost-cadfinal)).AND.(mod(iter,jump).EQ.0)) then
    	  write (105,*) iter,betasai((iter-(totamost-cadfinal))/jump,:)
 	  write (108,*) iter,efpolsai((iter-(totamost-cadfinal))/jump,:)
	  write(10,*) iter,lambdasai((iter-(totamost-cadfinal))/jump,:)
!	  write (111,*) iter,efclimsai((iter-(totamost-cadfinal))/jump,:)
	 endif
	 end do

	  write (109,*) acm/totamost,acb/(totamost*Comp),acd/totamost,
     + acrp/totamost,acrc/totamost,acefp/totamost,acefc/totamost,
     + aco/totamost

 	  close(unit=10)
	  close(unit=103)
	  close(unit=105)
	  close(unit=107)
	  close(unit=108)
	  close(unit=109)
	  close(unit=110)
!	  close(unit=111)
	  close(unit=112)
	  close(unit=113)
	  close(unit=116)

	 	
       write(*,*)'rejp: ',rejp
	 print *,"rejc",rejc
	 pause
	
	   END PROGRAM repar2

	   ! #####################################################################
	   ! #  INICIALIZAO DAS VARIVEIS
	   ! #
	   ! #  Comp   : Comprimento da srie temporal
	   ! #  nexpl  : Nmero de covariveis
	   ! #  flagdum: Indicadora da presena de dummies para dia da semana
	   ! #  flagsaz: Indicadora da presena se sazonalidade anual
	   ! #  nregr  : Total de regressoras: covariveis+dummies+sazonais
	   ! #  maxmiss: Nmero mximo de observaes missing
	   ! #
	   ! #####################################################################
	   SUBROUTINE  inicio ()
	   USE variables
	   IMPLICIT NONE
	
        
       dad ='pois_co_res_1431'
	   Comp=1401
         nexpl=1
	   nclim=2
	   nlag=0 ! nmero de defasagens na regressora
	   nsaz=4
	   comp=comp-nlag
         grav=1 ! # Geraes entre cada gravao
	   flagdum=0 !1, caso haja dummies, 0 caso contrrio
	   flagsaz=1 !1, caso haja sazonalidade, 0 caso contrrio
	   nregr=nexpl+nlag !uma regressora + defasagem
	   maxmiss=150
	   maxmissW=150
	   burning=1 !numero de iteracoes iniciais desprezadas
	   totamost =30000! Total de observacoes na amostra dividido por GRAV 
	   JUMP    = 10     !Salto na corrida para se obter as observacoes a serem
	 				    ! consideradas na analise
         cadfinal=10000   !numero de iteracoes para construir a cadeia final

                      


         ALLOCATE(missy(maxmiss),missing(maxmiss),
     +	   missingW(maxmissW,2),bt(comp),betaA(comp))
	   missy=0
	   missing=0
	   missingW=0
	   ALLOCATE(Xt(Comp),Yt(Comp),soma(nregr),cont(nregr)
     +   ,lamb(Comp),Wt(Comp,nclim),somaW(nclim),contW(nclim))
	   ALLOCATE(idmatb(comp,comp), St(comp,nsaz),idmato(nsaz,nsaz),
     +	   idmatd(nclim,nclim),Cdelta(nclim,nclim),mdelta(nclim)
     +      ,Comega(nsaz,nsaz),momega(nsaz))

       ! Parametros das Prioris 
!	    Cx (declarado dentro de Met_has e igual a 10000)
	   idmatb=0.0d0
	   do i=1,comp
	      do j=1,comp
	         if (i.EQ.j) then 
		        idmatb(i,j)=1.0d0
	         endif
	      end do
	   end do 

   
	   ab1=1.0d0
	   Rb1=100.0d0 
	   
	   idmatd=0.0d0
	   do i=1,nclim
	      do j=1,nclim
	         if (i.EQ.j) then 
		        idmatd(i,j)=1.0d0
	         endif
	      end do
	   end do 
	   Cdelta=100000.0d0*idmatd
	   mdelta=0.00d0

	  idmato=0.0d0
	   do i=1,(nsaz)
	      do j=1,(nsaz)
	         if (i.EQ.j) then 
		        idmato(i,j)=1.0d0
	         endif
	      end do
	   end do 
	   Comega=100000.0d0*idmato
	   momega=0.00d0




	   mefp=0.5d0 !mdia a priori de efpol0
	   Cefp=100.0d0 !varincia  apriori de efpol0
 	   mX=-0.6d0 !mdia a priori de x0
	   CX=0.005d0 !varincia  apriori de x0

	aC=0.000001d0	! par. forma a priori de Cbeta
	bC=0.000001d0	! par. escala a priori de Cbeta

	  
	
	  END SUBROUTINE inicio

	  ! #####################################################################
	  ! #   Lendo o arquivo de dados e montando dummies e sazonalidade 
	  ! #####################################################################

	  SUBROUTINE readdata()
	   USE variables
	   IMPLICIT NONE
     
	   CALL inicio() 
			 	
  !     LENDO O ARQUIVO DE DADOS
  !     ---------------------------
	   
	   imiss=0
	   imissy=0
	   imissW=0
         soma=0
	   somaW=0
	   cont=0
	   contW=0
       
      OPEN(90,FILE='c:\mariane\doutorado\DADOS\tese\'//dad//'.txt', 
     +	 STATUS='OLD')
   !   OPEN(91,
   !  +FILE='c:\mariane\doutorado\output\tese\mod4r1s0btszb\befinal.txt', 
   !  +	 STATUS='OLD')
      

      do i=1,Comp
	    READ(90,*) Yt(i),Xt(i),(Wt(i,k),k=1,nclim)
!	if (i .EQ. 1) then
!       betaA(i)=bt(i)
!	else
!	    betaA(i)=betaA(i-1)+bt(i)
!      endif

 !     L o pto inicial
!	    READ(91,*) betaA(i)
!	    if (i .EQ. 1) then
!           bt(i)=betaA(i)
!  	    else
!	     bt(i)=betaA(i)-betaA(i-1)
!	   endif


	    if (yt(i) .EQ. 999) then 
	       yt(i)=0
	       imissy=imissy+1
	       missy(imissy)=i
	    endif
	    do j=1,nexpl
	      if (Xt(i) .EQ. 99.9D0) then
		   imiss=imiss+1
	       missing(imiss)=i
	      endif
	    end do
	    do k=1,nclim
	        if (Wt(i,k) .NE. 99.9D0) then
	          somaW(k)=somaW(k)+Wt(i,k)
                contW(k)=contW(k)+1
	        else
		      imissW=imissW+1
	          missingW(imissW,1)=i
	          missingW(imissW,2)=k
	        endif
	    end do

	   end do
	  CLOSE(UNIT=90)
!	  CLOSE(UNIT=91)



         totmiss=imiss
	   totmissy=imissy
	   totmissw=imissw
!	   write(*,*) imiss,"  ",imissy
!	   pause

 

C	   CRIA DUMMIES PARA DIA DA SEMANA 
!      --------------------------------
!	   if (flagdum.EQ.1) then 
!  	     do i=1,Comp
!	        do j=(nexpl+1),nregr
!	           Xt(i,j)=0.0
!	           if (mod(i,7).NE.0) then 
!	              Xt(i,(nexpl+mod(i,7)))=1.0
!	           end if
!	        end do
!         end do
!	   end if

!	   MONTA SAZONALIDADE ANUAL
	   if (flagsaz.EQ.1) then 
	    do i=1,Comp
	       St(i,1)=COS(2*PI*i/365)
	       St(i,2)=SIN(2*PI*i/365)
	       St(i,3)=COS(4*PI*i/365)
	       St(i,4)=SIN(4*PI*i/365)

	    end do
	   end if

	  OPEN(20,FILE='c:\mariane\doutorado\OUTPUT\'//DAD//'.txt',
     +    STATUS='UNKNOWN')
	  do i=1,Comp
 	     write(20,21) yt(i),Xt(i),(Wt(i,k),k=1,nclim)
  21     format(F6.2,F10.2,F10.2,F10.2,F10.2,F6.2,F6.2,F6.2,
     +          F6.2,F6.2,F6.2,F6.2,F6.2,F6.2,F6.2)
	  end do
	  CLOSE(UNIT=20)

	  END SUBROUTINE readdata
 

	! #####################################################################
	! #                 METROPOLIS-HASTING	
    ! #   Gera uma realizao da distribuio conjunta
	! #####################################################################
	   					 
	  SUBROUTINE MET_HAS(TGrande,beta,delta,omega,W1
     +	  ,lamcalc)
	  ! TGrande  o comprimento da srie temporal
	  USE variables
 	  USE PORTLIB

	IMPLICIT NONE								 
      INTEGER, INTENT(IN) :: TGrande
	DOUBLE PRECISION, PARAMETER ::  d1=0.02d0,mmu=0.0d0,
     +  	Cm=0.001d0,varx=0.01d0,varbeta=0.00000005d0
      
      DOUBLE PRECISION :: mutA,lambda,ytil,Vtil,W1,varefp,varefpA,
     +lambdaA,ytilA,VtilA,razao,mm,sum,sumA,acumyt,funcw(TGrande,nclim),
     +funcx(TGrande,TGrande),funcxA(TGrande,TGrande),CbtA,mbtA,
     +funcwA(TGrande,nclim),indic(TGrande,TGrande),Cbt,mbt,
     +Cb(nregr,nregr),CbA(nregr,nregr),Cd(nclim,nclim),somaef,
     +CdA(nclim,nclim),detCbA,detCb,detCdA,detCd,somam,somab,
     +mbA(nregr),mdA(nclim),num,den,CmA,btprop,nC,nCSC,invC,
     +mb(nregr),md(nclim),mmA,beta(Tgrande),btA(Tgrande),me,meA,
     +betaprop(Tgrande),lamcalc(Tgrande),delta(nclim),deltaprop(nclim),
     +       vetum(nregr),auxdelta(nclim),auxbeta(Tgrande),
	+       efclimA(Tgrande),efpolA(TGrande),auxefp,auxefc,
     +       psipropp,u,unif,densnew,densold,auxx,x0prop,auxvet(nregr),
	+	   ran2,psipropc,efpolprop,efclimprop,rhopropp,rhopropc,
	+       detCo,detCoA,efsazA(Tgrande),omega(nsaz),omegaprop(nsaz),
	+       Co(nsaz,nsaz),CoA(nsaz,nsaz),mo(nsaz), moA(nsaz),
     +    auxomega(nsaz)

	DOUBLE PRECISION, DIMENSION(:)   :: 
     +	auxmediab(nregr),auxvb(nregr),auxv2b(nregr),auxmediad(nclim),
	+    auxvd(nclim),auxv2d(nclim),auxvo(nsaz),auxv2o(nsaz),
     +   auxmediao(nsaz)

	DOUBLE PRECISION, DIMENSION(:,:) :: 
     +	auxvarb(nregr,nregr),auxmb(nregr,nregr),auxvard(nclim,nclim),
     +    auxmd(nclim,nclim),
	+    auxvaro(nsaz,nsaz),auxmo(nsaz,nsaz)

            
      INTEGER :: t,indbeta,auxy,inddelta,indomega

	rejp=0
	rejc=0


! ---------Construo dos efpols----------
         funcx=0.0d0
 	   funcx(1,1)=xt(1)
	   efpol(1)=rhop*efpol0+funcx(1,1)*bt(1)
	   do t=2, TGrande	
	    funcx(t,1:t)=rhop*funcx(t-1,1:t)+xt(t)
   	  	efpol(t)=(rhop**t)*efpol0+dot_product(funcx(t,1:t),bt(1:t))
          end do


! ---------Construo dos efclims----------
 	  do t=1, TGrande
		efclim(t)=dot_product(wt(t,:),delta)
       end do

! ---------Construo dos efsazs----------
 	  do t=1, TGrande
		efsaz(t)=dot_product(st(t,:),omega)
       end do


    !  write(114,*) 'ef'

!     -----------
!	  GERA Mu 
!     -----------

        acumyt=0.0d0
	  do t=1,TGrande
	     acumyt=acumyt+yt(t)
	  end do

	     sum=0.0d0
	     do t=1,TGrande
	        lambda=mut+efpol(t)+efclim(t)+efsaz(t)
			sum=sum+dexp(lambda)
	     end do
		 call gNormal(mut,Cm,muta)
	     call lndNorm(mmu,W1,muta,num)
	     call lndNorm(mmu,W1,mut,den)

	     razao=num-den
  
           sumA=0.0d0
	     do t=1,TGrande
	        lambdaA=mutA+efpol(t)+efclim(t)+efsaz(t)
	        sumA=sumA+dexp(lambdaA)
	     end do

	     razao=razao+acumyt*(mutA-mut)-sumA+sum
 		 unif=ran2(sem)
	     if (razao.GE.dlog(unif)) then 
		     mut=mutA
		     aCm=aCm+1.0d0
	     endif


!	 ------------
!	  Gera erros 
!      ------------

   !      acumybt=0.0d0
         do t=1,TGrande
	     razao=0.0d0
	     if (t.EQ.1) then 
	        Cbt=1.0d0/Rb1
	     else
	        Cbt=1.0d0/Cbeta
	     endif
	     mbt=0.0d0
	     sum=0.0d0
	     do i=t,TGrande
	        lambda=mut+efpol(i)+efclim(i)+efsaz(i)
              razao=razao-yt(i)*lambda !vero (old) 
			sum=sum+dexp(lambda)!p/razao de verossimilhanas
			call modyt(yt(i),lambda,ytil)
	        call modVt(lambda,Vtil)
	 	    somab=efpol(i)-bt(t)*funcx(i,t)
	        mbt=mbt+((ytil-mut-efclim(i)-efsaz(i)-somab)
     +		*funcx(i,t))/Vtil
	        Cbt=Cbt+((funcx(i,t))**2/Vtil)
	     end do
	     if(t.eq.1) then
	       mbt=mbt+ab1/Rb1
	     endif
	     Cbt=1.0d0/Cbt
	     mbt=mbt*Cbt

 	     call gNormal(mbt,Cbt,btprop)
 	     call lndNorm(mbt,Cbt,btprop,num) 
	     razao=razao-num ! razao de propostas
	     do i=1,(t-1)
	        efpolA(i)=efpol(i)
          	betaprop(i)=beta(i)
	     end do
	     do i=t,TGrande 
		    efpolA(i)=efpol(i)-bt(t)*funcx(i,t)+btprop*funcx(i,t)
	        betaprop(i)=beta(i)-bt(t)+btprop
	     end do
	     if (t.EQ.1) then 
	        CbtA=1.0d0/Rb1
	     else 
	        CbtA=1.0d0/Cbeta
	     endif
           mbtA=0.0d0
	     sumA=0.0d0
	     do i=t,TGrande
	        lambdaA=mut+efpolA(i)+efclim(i)+efsaz(i)
              razao=razao+yt(i)*lambdaA !vero (new)
	        sumA=sumA+dexp(lambdaA)	!razao de verossimilhanas
	        call modyt(yt(i),lambdaA,ytilA)
	        call modVt(lambdaA,VtilA)
	        somab=efpolA(i)-btprop*funcx(i,t)
	        mbtA=mbtA+((ytilA-mut-efclim(i)-efsaz(i)-somab)
     +			*funcx(i,t))/VtilA
  	        CbtA=CbtA+((funcx(i,t))**2/VtilA)
	     end do

	     if (t.eq.1) then
	       mbtA=mbtA+ab1/Rb1
	     endif
	     CbtA=1.0d0/CbtA
		 mbtA=mbtA*CbtA
!		write(114,*) 'aqui',mbta,cbta,bt(t)

	     call lndNorm(mbtA,CbtA,bt(t),num)
!		write(114,*) 'aqui'

	     razao=razao+num ! razao de propostas
	     razao=razao-sumA+sum
	     if (t.EQ.1) then
	       call lndnorm(ab1,Rb1,btprop,num)
		   call lndnorm(ab1,Rb1,bt(t),den) 
	      else
             call lndnorm(0.0d0,Cbeta,btprop,num)
      	   call lndnorm(0.0d0,Cbeta,bt(t),den) 
	      endif
	     razao=razao+num-den
!		write(114,*) 'aqui'
		 unif=ran2(sem)
	     if (razao.GE.dlog(unif)) then 
	         bt(t)=btprop
	         beta=betaprop
		     efpol=efpolA
               lambda=lambdaA
		     acb=acb+1.0d0
	     endif
		   
	  end do

 
 
!	  -------------------
!	  Gera Delta 
!      -------------------
	   
	  inddelta=1
	  razao=0.0d0
    
	  Cd=Cdelta
 	  CALL inverse(nclim,Cd)	
	  md=matmul(Cd,mdelta)

	     lambda=mut+efpol(1)+efclim(1)+efsaz(1)
		 call modyt(yt(1),lambda,ytil)
	     call modVt(lambda,Vtil)
	!write(114,*) 'vtil'
	     auxvd=wt(1,:)*(ytil-mut-efpol(1)-efsaz(1))/Vtil
	     md=md+auxvd
	     auxvd=(1/Vtil)*wt(1,:)
	!write(114,*) 'auxvd'

	 	 CALL vvt(nclim,auxvd,wt(1,:),auxmd)
		 Cd=Cd+auxmd
	     razao=razao+dexp(lambda)
	!write(114,*) 'razao'
	
	  do t=2,TGrande
	     lambda=mut+efpol(t)+efclim(t)+efsaz(t)
		 call modyt(yt(t),lambda,ytil)
	     call modVt(lambda,Vtil)
	!write(114,*) t,'vtil'

	     auxvd=wt(t,:)*(ytil-mut-efpol(t)-efsaz(t))/Vtil
	     md=md+auxvd
	     auxvd=(1/Vtil)*wt(t,:)
	!write(114,*) 'auxvd'

	     auxv2d=wt(t,:)
	 	 CALL vvt(nclim,auxvd,auxv2d,auxmd)
		 Cd=Cd+auxmd
	     razao=razao+dexp(lambda)
	!write(114,*) 'razao'

		 densold=-razao
	  end do
        CALL inverse(nclim,Cd)
   	!write(114,*) 'inv'

	  md=matmul(Cd,md)

        CALL gNormult(nclim,md,Cd,deltaprop)
   	!write(114,*) 'gerou'

	!aqui fixa delta
	! deltaprop=delta

	  CdA=Cdelta
        CALL inverse(nclim,CdA)
        mdA=matmul(CdA,mdelta)
     	!write(114,*) 'mda'

	  efclimA(1)=dot_product(wt(1,:),deltaprop)
 		lambdaA=mut+efpol(1)+efclimA(1)+efsaz(1)
	    call modyt(yt(1),lambdaA,ytilA)
          call modVt(lambdaA,VtilA) 
   	!write(114,*) 'vtila'
			
	    auxvd=wt(1,:)*(ytilA-mut-efpol(1)-efsaz(1))/VtilA
 	    mdA=mdA+auxvd
          auxvd=(1/VtilA)*wt(1,:)
          CALL vvt(nclim,auxvd,wt(1,:),auxmd)
          CdA=CdA+auxmd
          razao=razao-dexp(lambdaA)

        do t=2,TGrande  
	    efclimA(t)=dot_product(wt(t,:),deltaprop)
 		lambdaA=mut+efpol(t)+efclimA(t)+efsaz(t)
          call modyt(yt(t),lambdaA,ytilA)
          call modVt(lambdaA,VtilA) 
   	!write(114,*) t,'vtila'
			
	    auxvd=wt(t,:)*(ytilA-mut-efpol(t)-efsaz(t))/VtilA
	    mdA=mdA+auxvd
          auxvd=(1/VtilA)*wt(t,:)
	    auxv2d=wt(t,:)
          CALL vvt(nclim,auxvd,auxv2d,auxmd)
   	!write(114,*) t,'vvt'

          CdA=CdA+auxmd
          razao=razao-dexp(lambdaA)
   	!write(114,*) t,'razao'

	    densnew=densnew-dexp(lambdaA)
        end do
    	   	!write(114,*) 'enddo'

        CALL inverse(nclim,CdA) 
 	   	!write(114,*) 'inv'
  


        mdA=matmul(CdA,mdA)

	  call determ(nclim,CdA,detCdA) 
	  call determ(nclim,Cd,detCd)
	   	!write(114,*) 'determ'

        if ((detCdA.LE.0.0d0) .OR. (detCd.LE.0.0d0)) then
           inddelta=0
        else
		 auxmediad=mda
		 auxvard=CdA
		 auxdelta=delta	  
		 call lndNM(nclim,auxmediad,auxvard,auxdelta,num)
	   	!write(114,*) 'lndnm1'

		 auxmediad=md 
		 auxvard=Cd
		 auxdelta=deltaprop
	     call lndNM(nclim,auxmediad,auxvard,auxdelta,den)
	   	!write(114,*) 'lndnm2'

	     razao=razao+num-den
        endif
	   	!write(114,*) t,'razao2'

        mdA=0.0d0
        CdA=Cdelta
        do t=1,TGrande
           auxvd=yt(t)*wt(t,:) 
           mdA=mdA+auxvd
        end do
        mdA=matmul(Cdelta,mdA)
        mdA=mdA+mdelta
		auxmediad=mdA
		auxvard=CdA
		auxdelta=deltaprop
	  call lndNM(nclim,auxmediad,auxvard,auxdelta,num)
	  densnew=densnew+NUM
	  auxmediad=mdA
	  auxvard=CdA
	  auxdelta=delta
	  call lndNM(nclim,auxmediad,auxvard,auxdelta,den)
	  densold=densold+den
        razao=razao+num-den
        unif=ran2(sem)
        if ((dlog(unif).LE. razao) .AND. inddelta.EQ.1) then
	   delta=deltaprop
         acd=acd+1.0d0
	   efclim=efclimA
        endif
!	  deallocate(auxmedia,auxvar,auxv,auxv2,auxm)


!	 -------------------
!	  Gera Omega 
!      -------------------
 !	  allocate(auxmedia(nclim),auxvar(nclim,nclim),auxv(nclim),
 !    +	  auxv2(nclim),auxm(nclim,nclim))
        indomega=1
	  razao=0.0d0
    
	  Co=Comega

 	  CALL inverse(nsaz,Co)	
	  mo=matmul(Co,momega)

	     lambda=mut+efpol(1)+efclim(1)+efsaz(1)
		 call modyt(yt(1),lambda,ytil)
	     call modVt(lambda,Vtil)
	     auxvo=st(1,:)*(ytil-mut-efpol(1)-efclim(1))/Vtil
	     mo=mo+auxvo
	     auxvo=(1/Vtil)*st(1,:)
	!write(114,*) 'auxvd'

	 	 CALL vvt(nsaz,auxvo,st(1,:),auxmo)
		 Co=Co+auxmo
	     razao=razao+dexp(lambda)
	!write(114,*) 'razao'
	
	  do t=2,TGrande
	     lambda=mut+efpol(t)+efclim(t)+efsaz(t)
		 call modyt(yt(t),lambda,ytil)
	     call modVt(lambda,Vtil)
	!write(114,*) t,'vtil'

	     auxvo=st(t,:)*(ytil-mut-efpol(t)-efclim(t))/Vtil
	     mo=mo+auxvo
	     auxvo=(1/Vtil)*st(t,:)
	!write(114,*) 'auxvd'

	     auxv2o=st(t,:)
	 	 CALL vvt(nsaz,auxvo,auxv2o,auxmo)
		 Co=Co+auxmo
	     razao=razao+dexp(lambda)
	!write(114,*) 'razao'

		 densold=-razao
	  end do
        CALL inverse(nsaz,Co)
   	!write(114,*) 'inv'

	  mo=matmul(Co,mo)

        CALL gNormult(nsaz,mo,Co,omegaprop)
   	!write(114,*) 'gerou'

	!aqui fixa delta
	! deltaprop=delta

	  CoA=Comega
        CALL inverse(nsaz,CoA)
        moA=matmul(CoA,momega)
     	!write(114,*) 'mda'

	  efsazA(1)=dot_product(st(1,:),omegaprop)
 		lambdaA=mut+efpol(1)+efclimA(1)+efsazA(1)
	    call modyt(yt(1),lambdaA,ytilA)
          call modVt(lambdaA,VtilA) 
   	!write(114,*) 'vtila'
			
	    auxvo=st(1,:)*(ytilA-mut-efpol(1)-efclim(1))/VtilA
 	    moA=moA+auxvo
          auxvo=(1/VtilA)*st(1,:)
          CALL vvt(nsaz,auxvo,st(1,:),auxmo)
          CoA=CoA+auxmo
          razao=razao-dexp(lambdaA)

        do t=2,TGrande  
	    efsazA(t)=dot_product(st(t,:),omegaprop)
 		lambdaA=mut+efpol(t)+efclimA(t)+efsazA(t)
          call modyt(yt(t),lambdaA,ytilA)
          call modVt(lambdaA,VtilA) 
   	!write(114,*) t,'vtila'
			
	    auxvo=st(t,:)*(ytilA-mut-efpol(t)-efclim(t))/VtilA
	    moA=moA+auxvo
          auxvo=(1/VtilA)*st(t,:)
	    auxv2o=st(t,:)
          CALL vvt(nsaz,auxvo,auxv2o,auxmo)
   	!write(114,*) t,'vvt'

          CoA=CoA+auxmo
          razao=razao-dexp(lambdaA)
   	!write(114,*) t,'razao'

	    densnew=densnew-dexp(lambdaA)
        end do
    	   	!write(114,*) 'enddo'

        CALL inverse(nsaz,CoA) 
 	   	!write(114,*) 'inv'
  


        moA=matmul(CoA,moA)

	  call determ(nsaz,CoA,detCoA) 
	  call determ(nsaz,Co,detCo)
	   	!write(114,*) 'determ'

        if ((detCoA.LE.0.0d0) .OR. (detCo.LE.0.0d0)) then
           indomega=0
        else
		 auxmediao=moa
		 auxvaro=CoA
		 auxomega=omega	  
		 call lndNM(nsaz,auxmediao,auxvaro,auxomega,num)
	   	!write(114,*) 'lndnm1'

		 auxmediao=mo 
		 auxvaro=Co
		 auxomega=omegaprop
	     call lndNM(nsaz,auxmediao,auxvaro,auxomega,den)
	   	!write(114,*) 'lndnm2'

	     razao=razao+num-den
        endif
	   	!write(114,*) t,'razao2'

        moA=0.0d0
        CoA=Comega
        do t=1,TGrande
           auxvo=yt(t)*st(t,:) 
           moA=moA+auxvo
        end do
        moA=matmul(Comega,moA)
        moA=moA+momega
		auxmediao=moA
		auxvaro=CoA
		auxomega=omegaprop
	  call lndNM(nsaz,auxmediao,auxvaro,auxomega,num)
	  densnew=densnew+NUM
	  auxmediao=moA
	  auxvaro=CoA
	  auxomega=omega
	  call lndNM(nsaz,auxmediao,auxvaro,auxomega,den)
	  densold=densold+den
        razao=razao+num-den
        unif=ran2(sem)
        if ((dlog(unif).LE. razao) .AND. indomega.EQ.1) then
	   omega=omegaprop
         aco=aco+1.0d0
	   efsaz=efsazA
        endif
!	  deallocate(auxmedia,auxvar,auxv,auxv2,auxm)

 

 
!     -----------------------------		  
!
!          Gera efpol0
!     -----------------------------

	   razao=0.0d0
	   somaef=0.0d0
	   varefp=1.0d0/Cefp
	   me=varefp*mefp
	   do t=1,TGrande
	        lambda=mut+efpol(t)+efclim(t)+efsaz(t)
			razao=razao+dexp(lambda)
	        call modyt(yt(t),lambda,ytil)
	        call modvt(lambda,vtil)
	        auxefp=(rhop**t)*(ytil-mut-dot_product(funcx(t,1:t),
     +			bt(1:t))-efclim(t)-efsaz(t))/vtil
	        me=me+auxefp
	        auxefp=(1/vtil)*rhop**(2*t)
	        varefp=varefp+auxefp
	   end do
	   varefp=1.0d0/varefp
	   me=varefp*me
	   call gnormal(me,varefp,efpolprop)
	!aqui fixa efpol
	!   efpolprop=efpol0
	   
	  varefpA=1.0d0/Cefp
	  meA=varefpA*mefp
	  do t=1,TGrande
   	  	efpolA(t)=(rhop**t)*efpolprop + 
     +	dot_product(funcx(t,1:t),bt(1:t))
		lambdaA=mut+efpolA(t)+efclim(t)+efsaz(t)
	    razao=razao-dexp(lambdaA)
	    call modyt(yt(t),lambdaA,ytilA)
	    call modvt(lambdaA,vtilA)
	    auxefp=(rhop**t)*(ytilA-mut-dot_product(funcx(t,1:t),
     +			bt(1:t))-efclim(t)-efsaz(t))/vtilA
	    meA=meA+auxefp
	    auxefp=(1/vtilA)*rhop**(2*t)
	    varefpA=varefpA+auxefp
	    somaef=somaef+yt(t)*rhop**t
	   end do
	   varefpA=1.0d0/varefpA
	   meA=varefpA*meA
	   call lndnorm(meA,varefpA,efpol0,num)
	   call lndnorm(me,varefp,efpolprop,den)
	   razao=razao+num-den
	   call lndNorm(mefp,Cefp,efpolprop,num)
	   call lndNorm(mefp,Cefp,efpol0,den)
	   razao=razao + (efpolprop-efpol0)*somaef+ num-den

	   u=ran2(sem)
	   if (dlog(u).LE.razao) then
	      acefp=acefp+1.0d0 
	      efpol0=efpolprop
	      efpol=efpolA
	      lambda=lambdaA
	   endif
!     -----------------------------		  
!          Gera X0
!     -----------------------------
!	   razao=0.0d0
!	   auxx=0.0d0
!	   do t=1,TGrande
!	        lambda=mut+efpol(t)+efclim(t)
!			razao=razao+dexp(lambda)
!	   end do
!	   call gnormal(x0,varx,x0prop)
!	   funcxA(1,:)=xt(1,1)
!	   funcxA(1,2)=x0prop
!	   efpolA(1)=rhop*efpol0+dot_product(funcxA(1,:),beta)
!	   lambdaA=mut+efpolA(1)+efclim(1)
!	   razao=razao-dexp(lambdaA)
!       auxx=auxx+yt(1)
!	   do t=2, TGrande						
!	      funcxA(t,1)=rhop*funcxA(t-1,1)+xt(t,1)
!	      funcxA(t,2)=rhop*funcxA(t-1,2)+xt(t-1,1)
!	      efpolA(t)=(rhop**t)*efpol0+dot_product(funcxA(t,:),beta)
!	      lambdaA=mut+efpolA(t)+efclim(t)
!	      razao=razao-dexp(lambdaA)
!	      auxx=auxx+yt(t)*rhop**(t-1)
!       end do
!	   call lndNorm(mX,CX,x0prop,num)
!	   call lndNorm(mX,CX,x0,den)
!	   razao=razao + (x0prop-x0)*beta(2)*auxx+ num-den
!
!	   u=ran2(sem)
!	   if (dlog(u).LE.razao) then
!	      acx0=acx0+1.0d0 
!	      x0=x0prop
!	      funcx=funcxA
!	      efpol=efpolA
!	   endif
!
!	write(114,*) 'x0'


 !    -----------------------------
 !         Gera rhop
 !    -----------------------------
	  psip=dlog(rhop/(1-rhop))
2000	  call gnormal(psip,d1,psipropp)
	  rhopropp=dexp(psipropp)/(1+dexp(psipropp))
        if (rhopropp.EQ.1.0d0) then
	      rejp=rejp+1
	      goto 2000
	  endif 

	! aqui fixa rho
	! rhopropp=rhop

	  razao=psipropp-2*dlog(1+dexp(psipropp))-psip+
     +	  2*dlog(1+dexp(psip))	   !razao de jacobianos

         funcxA=0.0d0
 	   funcxA(1,1)=xt(1)
	   efpolA(1)=rhopropp*efpol0+funcxA(1,1)*bt(1)
 	   razao=razao+(yt(1)*(efpolA(1)-efpol(1)))+(dexp(mut)
     +        *dexp(efclim(1))*(dexp(efpol(1))-dexp(efpolA(1))))

	   do t=2, TGrande	
	    funcxA(t,1:t)=rhopropp*funcxA(t-1,1:t)+xt(t)
   	  	efpolA(t)=(rhopropp**t)*efpol0+
     +    dot_product(funcxA(t,1:t),bt(1:t))
		razao=razao+(yt(t)*(efpolA(t)-efpol(t)))+(dexp(mut)*
     +        dexp(efclim(t))*(dexp(efpol(t))-dexp(efpolA(t))))

         end do

 
	   u=ran2(sem)
	   if (dlog(u).LE.razao) then
	      acrp=acrp+1.0d0
	      rhop=rhopropp
	      funcx=funcxA
	      efpol=efpolA
	   endif
!   -------------------------------
!	  GERA Y(t) QUANDO MISSING
!     -------------------------------
!   
	  do t=1,totmissy
   		call gPoisson(dexp(mut+ 
     +	efpol(missy(t))+efclim(missy(t))),auxy)
		yt(missy(t))=1.0d0*auxy
	  end do

 !    -------------------
 !      Gera Cbeta 
 !    -------------------

        nC=aC+(TGrande-1.0)/2d0 
        somam=0.0d0
        do t=2,TGrande
           somam=somam+(bt(t)**2)/2         
        end do
       nCSC=bC+somam 
	   call gGamma(nC,nCSC,invC)
      Cbeta=1/invC
  
 
	 do t=1,Tgrande
	    lamcalc(t)=dexp(mut+ efpol(t)+efclim(t)+efsaz(t))
	end do
	!write(114,*) 'y'


	RETURN 
      END SUBROUTINE MET_HAS




	! #########################################################
	! #                                                       #
	! #  Este modulo contem todas as  rotinas                 #
	! #  que so utilizadas ao longo do programa              #
	! #                                                       #
      ! #########################################################

	   SUBROUTINE modyt (y,lambda,mody)
	   IMPLICIT NONE
	   DOUBLE PRECISION :: y,lambda,mody
          mody=lambda+y/dexp(lambda)-1
	    return
         END 

	  SUBROUTINE modVt (lambda,modV)
	   IMPLICIT NONE
	   DOUBLE PRECISION :: lambda,modV
	    modV=1.0d0/dexp(lambda)
	   return
        END 

	! #########################################################
	! # GERACAO DE QUANTIDADES ALEATORIAS
	! #########################################################


	!Gerao de valores com distribuio U(0,1)
	!
      ! ran2 from 2nd Edn of Numerical Recipes
      !

	real*8 FUNCTION ran2(ISEED)
	implicit none
      INTEGER iseed,im1,im2,imm1,ia1,ia2,iq1,iq2,ir1,ir2,ntab,ndiv
      REAL*8 am,eps,rnmx
      PARAMETER(im1=2147483563,im2=2147483399,am=1./im1,imm1=im1-1,
     +   ia1=40014,ia2=40692,iq1=53668,iq2=52774,ir1=12211,
     +   ir2=3791,ntab=32,ndiv=1+imm1/ntab,eps=1.2e-7,rnmx=1.-eps)
      INTEGER idum2,j,k,iv(ntab),iy
!
      SAVE IV,IY,IDUM2
!
      DATA idum2/123456789/,iv/ntab*0/,iy/0/
      IF (iseed.LE.0) THEN
         iseed=MAX(-iseed,1)
         idum2=iseed
         DO j=ntab+8,1,-1
            k=iseed/iq1
            iseed=ia1*(iseed-k*iq1)-k*ir1
            IF (iseed.LT.0) iseed=iseed+im1
            IF (j.LE.ntab) iv(j)=iseed
         ENDDO
         iy=iv(1)
      ENDIF
      k=iseed/iq1
      iseed=ia1*(iseed-k*iq1)-k*ir1
      IF (iseed.LT.0) iseed=iseed+im1
      k=idum2/iq2
      idum2=ia2*(idum2-k*iq2)-k*ir2
      IF (idum2.LT.0) idum2=idum2+im2
      j=1+iy/ndiv
      iy=iv(j)-idum2
      iv(j)=iseed
      IF (iy.LT.1) iy=iy+imm1
      ran2=MIN(am*iy,rnmx)

      RETURN
      END



	! Gera valores com distribuio Poisson(lambda)
	! Algoritmo em Ross, 1997, p.64
	SUBROUTINE gPoisson(lambda,gpois)
	IMPLICIT NONE
	DOUBLE PRECISION, INTENT(IN) :: lambda
	DOUBLE PRECISION :: prod,z,aux
	INTEGER :: cont,gpois
	REAL    :: unif

	if (lambda .LE. 50) then 
      cont=0
	  prod=1.0d0
      do while (prod.GE.dexp(-lambda))
	  call random(unif)
      prod=prod*unif
	  cont=cont+1
	  end do
  	  gpois=cont-1
	else  !aproximao normal p/ lambda grande (v. Rubinstein)
	  call gNormal(0.0d0, 1.0d0,z)
!	  write(*,*) 'gerou z'
	  aux=lambda+z*sqrt(lambda)-0.5d0
!	  write(*,*) 'calculou aux'
	  gpois=max(0,nint(aux))
!	  write(*,*) 'calculou max'
	endif


	return
      END 


	  ! Gera valores com distribuio Normal(lambda)
	  ! Algoritmo em 
  	   SUBROUTINE gNormal(media,vari,geranorm)
       IMPLICIT REAL*8 (A-H,O-Z)
	   DOUBLE PRECISION  :: media, vari,pad,theta,pi
	   real*4 u0,u1
	   pi=3.14159d0 
	   call random(u0)
	   call random(u1)
46	   if (u1.EQ.0.0) then 
	     goto 46
	   endif	  
	   theta=2.0d0*pi*u0
	   e=-log(u1)
	   r=sqrt(2*e)
	   pad=r*dcos(theta)
	   geranorm=media+pad*dsqrt(vari)

       return
       end



    	! Gera valores com distribuio Normal Multivariada(mu,sig)
	    SUBROUTINE gNormult( dim,mu, sig,sai)
        IMPLICIT NONE
        INTEGER :: dim,i   
        DOUBLE PRECISION :: mu(dim),sig(dim,dim),sai(dim),Z(dim),
     +                      S(dim,dim)
          
   	      Z=0.0d0
            do i=1,dim
               call gnormal(0.0d0,1.0d0,Z(i))
            end do
            CALL cholesky(sig,S,dim)
            S=transpose(S)
            sai=matmul(S,Z)
            sai=mu+sai
           END SUBROUTINE gNormult

	   subroutine gExpo(p1,geraexp)
       IMPLICIT REAL*8 (A-H,O-Z)
       real*4 u0
	    
45	   call random(u0)
	   if (u0.EQ.1.0) then 
	    goto 45
	   endif
        
         geraexp=-(1/p1)*log(1-u0)

       return
       end



         ! Gera Gamma 
       SUBROUTINE gGamma(p1,p2,geraxb)
       IMPLICIT REAL*8 (A-H,O-Z)
       real*4 u0,u1
  
	   if (dmod(p1,0.5d0).EQ.0) then   !primeiro caso: 2*alpha  inteiro


	     if (dmod(p1,1.0d0).EQ.0) then !alpha  inteiro
	      qui=0.0
	      do i=1,p1
	         call gExpo(0.5d0,valexp)
		     qui=qui+valexp
		  end do
	      geraxb=qui/(2*p2)     
	     else 			    !alpha no  inteiro (=0.5,1.5,2.5,...)
	      qui=0.0
	      aux=int(p1)
	  	 do i=1,aux
		     call gExpo(0.5d0,valexp)
		     qui=qui+valexp
		     end do
		  call gNormal(0.0d0,1.0d0,valnorm)
		  qui=qui+exp(2*log(abs(valnorm)))  
		  geraxb=qui/(2*p2)	
          endif   
	               
	   else
         if(p1.LT.1)then   !segundo caso:(2*alpha no inteiro, alpha<1)

5          call random(u0)
           call random(u1)
           if(u0.GT.DEXP(1.0d0)/(p1+DEXP(1.0d0))) then
             aux=-DLOG((p1+DEXP(1.0d0))*(1-u0)/(p1*DEXP(1.0d0)))
	       if (u1.GT.DEXP((P1-1)*DLOG(aux))) then 
		       goto 5
	       endif
           else
            aux=DEXP((1.0d0/p1)*DLOG(((p1+DEXP(1.0d0))*u0)/DEXP(1.0d0)))
	      if (u1.GT.DEXP(-aux)) then
	           goto 5
	      endif
           endif
           geraxb=(1.0d0/p2)*aux

         else !terceiro caso:(2*alpha no inteiro, alpha>=1)

	       c1=p1-1
           c2  =(p1-(1/(6*p1)))/c1
           c3=2/c1
           c4=c3+2
           c5=1/(dsqrt(p1))
        
55         call random(u0)
           call random(u1)
           if(p1.gt.2.5) then
             u0=u1+c5*(1-(1.86*u0))
           endif
           if((u0.LE.0).OR.(u0.GE.1)) then
             goto 55
           endif
           ww=(c2*u1)/u0
           if ((c3*u0+ww+(1/ww)).LE.c4) then
            isai=1
           endif
           if ((c3*LOG(u0)-DLOG(ww)+ww).GE.1) then
            isai=0
           endif
           if (isai.EQ.0) then
             goto 55
           endif
           geraxb=(1.0d0/p2)*c1*ww
	     endif
	   endif
       return
       end



	! #########################################################
	! # AVALIAO DE DENSIDADES
	! #########################################################
	  

      SUBROUTINE lndNorm( media, vari, x,lndNor)
	   IMPLICIT NONE
	   DOUBLE PRECISION :: media, vari,x,lndNor
	   REAL,PARAMETER :: PI=3.141592653589793
         ! Calcula o ln da densidade da Normal(media,vari) no ponto x 
	     lndNor=-1/(2*vari)*(x-media)*(x-media)-0.5*dlog(2*PI*vari)
	   return
	   END 

         SUBROUTINE lndNM( dim,media,vari,x,lndN)
         !Calcula o ln da densidade normal multivariada (media,vari) no ponto x
          IMPLICIT NONE
          INTEGER :: dim   
          DOUBLE PRECISION :: media(dim),vari(dim,dim),x(dim),
     +                        auxm(dim,dim),auxv1(dim),auxv2(dim),aux,
     +	                        lndN,detvari
	    REAL,PARAMETER ::PI=3.141592653589793 
          auxv1=(-1.0)*media
          auxv1=x+auxv1
	    auxm=vari
          CALL inverse(dim,auxm)
          auxv2=matmul(auxm,auxv1)
          aux=(-1.0)*0.5*dim*dlog(2.0d0*PI)-0.5*dot_product(auxv1,auxv2)
	    call determ(dim,vari,detvari)
          lndN=aux-0.5*dlog(detvari)
		  return
         END 

	  
	! #########################################################
	! # OPERAES MATRICIAIS
	! #########################################################

	! escalar vezes matriz 

	   SUBROUTINE evm(e,m,sai)
	    USE variables
	    IMPLICIT NONE
	    DOUBLE PRECISION :: m(nregr,nregr),sai(nregr,nregr),e
                  
	    sai=0.0d0
          do i=1,nregr
	       do j=1,nregr
		      sai(i,j)=e*m(i,j) 
		   end do 
		end do 
	   END SUBROUTINE evm
		      
   	! Faz multiplicacao de vetor transposto por vetor
	   SUBROUTINE  vtv(dim, v1, v2,vtvaux)
	    INTEGER, INTENT(IN) :: dim
	    INTEGER :: i
	    DOUBLE PRECISION :: v1(dim),v2(dim),C,vtvaux

          C=0.0d0
          do i=1,dim
	        C=C+v1(i)*v2(i)
	    end do
	    vtvaux=C
         END 

   	! Faz multiplicacao de vetor por vetor transposto
	   SUBROUTINE vvt( dim,v1,v2,sai)
	    IMPLICIT NONE
          INTEGER, INTENT(IN) :: dim
	    INTEGER :: i, j
	    DOUBLE PRECISION :: v1(dim),v2(dim),sai(dim,dim)

          sai=0.0d0
	    do i=1,dim
	       do j=1,dim
		      sai(i,j)=v1(i)*v2(j)
	       end do
	    end do
	   END SUBROUTINE vvt
	 	
	 ! Inverte matriz(nregr,nregr) 

c	   SUBROUTINE minv(mat,sai)
c	    USE variables
c	    IMPLICIT NONE
c	    DOUBLE PRECISION :: mat(nregr,nregr),sai(nregr,nregr),
c     +                     B(nregr,2*nregr),aux,pivot
c          INTEGER ::  piv
c      
c          do i=1,nregr
c	        do j=1,nregr
c	           B(i,j)=mat(i,j)
c		    end do
c	    end do  
c	    do i=1,nregr
c	       do j=(nregr+1),(2*nregr)
c	          B(i,j)=0
c		   end do
c	    end do 
c	    do i=1,nregr
c	       B(i,(nregr+i))=1.0d0
c	    end do 
c	    do i=1,nregr
c             pivot=B(i,i)
c		   piv=i
c		   if (i.LT.nregr) then 
c		      do k=(i+1),nregr 
c		         if (abs(pivot).LT.abs(B(k,i))) then
c	                 pivot=B(k,i)
c	                 piv=k
c	             endif
c	          end do
c	       endif
c	       if (i.NE.piv) then
c		      do j=1,(2*nregr)
c	             aux=B(i,j)
c			     B(i,j)=B(piv,j)
c			     B(piv,j)=aux
c	          end do
c	       endif
c	       do j=i,(2*nregr)
c		      B(i,j)=B(i,j)/pivot
c	       end do
c	       if (i.LT.nregr) then
c		      do k=(i+1),nregr
c	             aux=B(k,i)
c                   do j=1,(2*nregr)
c	                 B(k,j)=B(k,j)-B(i,j)*aux
c		         end do
c	  	      end do
c 		   endif
c		   if (i.GT.1) then 
c		      do k=1,(i-1)
c                   aux=B(k,i)
c	             do j=i,(2*nregr)
c			        B(k,j)=B(k,j)-B(i,j)*aux
c	             end do
c    	          end do
c	       endif
c	    end do
c    	      
c	    do i=1,nregr
c	       do j=1,nregr
c		      sai(i,j)=B(i,(nregr+j))
c		   end do
c	    end do 
c	   END SUBROUTINE minv
        
       !Faz decomposio de Choleski
c       SUBROUTINE chol( dim,mat, sai)
c	   IMPLICIT NONE
c         INTEGER :: i, j, k,dim
c	   DOUBLE PRECISION :: mat(dim,dim),sai(dim,dim),U(dim,dim),aux
c        
c	   U=0.0d0
c        do i=1,dim
c           aux=0.0d0
c           if (i.GT.1) then 
c              do k=1,(i-1) !VAI DAR PROBLEMA PARA i=1???
c                 aux=aux+(U(k,i))**2
c              end do
c		   endif
c           U(i,i)=(mat(i,i)-aux)**0.5
c           do j=(i+1), dim
c              aux=0.0d0
c              if (i.GT.1) then 
c                 do k=1,(i-1)
c                    aux=aux+U(k,i)*U(k,j)
c                 end do
c			  endif
c              U(i,j)=(mat(i,j)-aux)/U(i,i)
c           end do
c        end do
c        sai=U
c       END SUBROUTINE chol

       SUBROUTINE mt( dim,mat,sai)
       !calcula a transposta da matriz (dim,dim) 
	 USE variables
	 IMPLICIT NONE
       INTEGER  dim
	  DOUBLE PRECISION :: mat(dim,dim),sai(dim,dim)

         sai=0.0d0
         do i=1,nregr
           do j=1, nregr
              sai(j,i)=mat(i,j)
           end do 
         end do
         END SUBROUTINE mt

       SUBROUTINE determ(dim,mat,detaux)
       ! Calcula determinante de matriz(dim,dim)
        IMPLICIT NONE
        INTEGER :: i, j, k,dim,piv
        DOUBLE PRECISION :: mat(dim,dim),aux,pivot,det,detaux
        
        det=1.0d0
        do i=1,dim
           pivot=mat(i,i)
           piv=i
           if (i.LT.dim)then
              do k=(i+1),dim
                 if (abs(pivot).LT.abs(mat(k,i))) then
                    pivot=mat(k,i)
                    piv=k
                 endif
              end do
           endif 
           if (i.NE.piv) then
              det=(-1.0)*det
              do j=1,dim
                 aux=mat(i,j)
                  mat(i,j)=mat(piv,j)
                  mat(piv,j)=aux
              end do
            endif
            do j=i,dim
               mat(i,j)=mat(i,j)/pivot
            end do
            det=det*pivot
            if (i.LT.dim) then 
               do k=(i+1),dim
                 aux=mat(k,i)
                 do j=1,dim
                    mat(k,j)=mat(k,j)-mat(i,j)*aux
                 end do
               end do
	      endif
         end do
         detaux=det
		 return
       END 


 	 	 
   

