!   **********************************************************************
!   Trata o problema de anlise de sries Poisson, com sazonalidade, efpol aleatrio  
!   e variveis regressoras, via Metropolis-Hasting. Movimento componente a componente.
!   O nvel  estimado, porm no evolui no tempo
!   Funo de transferncia com nlag defasagens na regressora
!   Proposta normal para o logito dos parmetros autoregressivos
!   **********************************************************************

	! #####################################################b###
	! #                                                       #
	! #  Este modulo contem todas as variaveis que serao      #
	! #  utilizadas nesta e em outras subrotinas ou funcoes   #
	! #                                                       #
	! #########################################################

      MODULE variables
	IMPLICIT NONE
	SAVE
	DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:) :: 
     +  Xt,idmatb,Cbeta,Wt,idmatd,Cdelta,betasai,deltasai,efpolsai,
	+ lambdasai,efclimsai,Cdeltad,deltadsai,Dt,idmatdd,ytsai
	INTEGER, ALLOCATABLE, DIMENSION(:,:) :: missing,missingW
	DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:)   :: 
     +  Yt,soma,mbeta,betaA,lamb, mmAux,CmAux,probac,efpol,
	+  efclim,mdelta,somaW,deltaA,rhosai,musai,ef0sai,alphasai,
     +	  deltadA,mdeltad

	INTEGER, ALLOCATABLE, DIMENSION(:)   :: 
     +  cont,contW,missy
	CHARACTER*9 dad
	character*12 saida
	DOUBLE PRECISION :: acx0,aCm,acb,acd,rhop,acrp,acrc,acefp,acefc,
     +  postnovo,postvelho,propnovo,propvelho,mut,efpol0,efclim0,rhoc,
	+  mefp,Cefp,mefc,Cefc,psip,psic,x0,mX,Cx,alpha,aa,la,acalpha,lixo2
	+  ,acdd


	INTEGER :: nregr,maxmiss,Comp,nexpl,nclim,flagdum,flagsaz,maxmissW
	+           ,totmissy,i,j,k,imiss,imissy,grav,burning,totamost,
     +           jump,iter,status,sem,lixo,totmiss,imissW,totmissw,l,
	+           rejp,rejc,nlag,cadfinal,ndia

	REAL,PARAMETER ::PI=3.141592653589793
 

	END MODULE variables

	
	   ! #####################################################################
	   ! #
 	   ! #  PROGRAMA PRINCIPAL 
         ! #
 	   ! #####################################################################

	   PROGRAM repar2
	   USE variables
	   IMPLICIT NONE
	   DOUBLE PRECISION ::	w1A
	   	   
	   	write(*,'(1X,A\)') 'nome do arq saida:'
 	    read (*,'(A)') saida
	 
	   print *,"Program repar2..."
	   CALL readdata()

	    call gettim(status,status,status,sem)
          call seed(sem)


	 ! Valores iniciais 

	   ALLOCATE(betaA(nregr),deltaA(nclim),mmAux(comp)
     +   ,CmAux(comp),probac(comp),efpol(comp),efclim(comp),
     + rhosai(totamost),musai(totamost),betasai(totamost,nregr),
     + deltasai(totamost,nclim),ef0sai(totamost),alphasai(totamost),
     + efpolsai((cadfinal/jump),comp),efclimsai((cadfinal/jump),comp),
     + lambdasai((cadfinal/jump),comp),deltadA(ndia),
     +deltadsai(totamost,ndia),ytsai(totamost,totmissy))
         mut=0.5d0
	   betaA=0.05d0
	   deltaA=0.05d0
	   deltadA=0.05d0
	   mmAux=0.0d0
	   CmAux=0.0d0
	   probac=0.0d0
	   efpol=0.0d0
	   efclim=0.0d0
	   efpol0=0.5d0
	   W1A=100000.0d0
	   x0=-0.676972592d0
	   alpha=1.0d0
	   rhop=0.2d0
	   print*,"Burning . . ."

c  **************************************************
	  aCm=0.0d0
	  acb=0.0d0
	  acd=0.0d0
	acdd=0.0d0
	  acrp=0.0d0
	  acefp=0.0d0
	  acx0=0.0d0
	  acalpha=0.0d0

       !Gera uma corrida do vetor parametrico via Metropolis-Hasting 




       do iter=1,TOTAMOST
	       call Met_Has(comp,betaA,deltaA,deltadA,W1A,lamb)

		     write(*,*) iter
         
	       rhosai(iter) =rhop
		   musai(iter)=mut
	       betasai(iter,:)=	betaA
	       deltasai(iter,:)=deltaA
		   deltadsai(iter,:)=deltadA
	       ef0sai(iter)=efpol0
	       alphasai(iter)=alpha
	       ytsai(iter,:)=yt(478:479)
	
	           
	if ((iter.GT.(totamost-cadfinal)).AND.(mod(iter,jump).EQ.0)) then
	           efpolsai((iter-(totamost-cadfinal))/jump,:)=efpol
	           lambdasai((iter-(totamost-cadfinal))/jump,:)=lamb
 	           efclimsai((iter-(totamost-cadfinal))/jump,:)=efclim
	endif
             
      end do

	OPEN(10,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\mean.txt'
     +,status='unknown')
	OPEN(103,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\rh.txt'
     +,status='unknown')
	open(105,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\be.txt'
     +,status='unknown')
	open(107,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\mu.txt'
     +,status='unknown')
	open(108,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\efp.txt'
     +,status='unknown')
 	open(109,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\ac.txt'
     +,status='unknown')
	open(110,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\de.txt'
     +,status='unknown')
	open(111,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\efc.txt'
     +,status='unknown')
   	open(112,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\ef0.txt'
     +,status='unknown')
  	open(113,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\x0.txt'
     +,status='unknown')
  	open(115,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\al.txt'
     +,status='unknown')
  	open(116,
     +file='c:\mariane\doutorado\output\tese\gar1s0szb\yt.txt'
     +,status='unknown')


      do iter=1,TOTAMOST
	write(*,*) 'grav: ',iter
	 write (103,*) rhosai(iter)
    	  write (105,*)betasai(iter,:)
	 write (107,*) musai(iter)
	 write(110,200)  deltasai(iter,:),deltadsai(iter,:)
  200	 format(F7.4,F7.4,F7.4,F7.4,F7.4,F7.4,F7.4,F7.4,F7.4)
	 write(112,*) ef0sai(iter)
	 write(115,*) alphasai(iter)
	 write(116,*) ytsai(iter,:)

	 if ((iter.GT.(totamost-cadfinal)).AND.(mod(iter,jump).EQ.0)) then
 	  write (108,*) iter,efpolsai((iter-(totamost-cadfinal))/jump,:)
	  write(10,*) iter,lambdasai((iter-(totamost-cadfinal))/jump,:)
	  write (111,*) iter,efclimsai((iter-(totamost-cadfinal))/jump,:)
	 endif
	 end do
	

	  write (109,*) acm/totamost,acb/(totamost),acd/totamost,
     + acrp/totamost,acrc/totamost,acefp/totamost,acefc/totamost,
     + acx0/totamost,acalpha/totamost,acdd/totamost

 	  close(unit=10)
	  close(unit=103)
	  close(unit=105)
	  close(unit=107)
	  close(unit=108)
	  close(unit=109)
	  close(unit=110)
	  close(unit=111)
	  close(unit=112)
	  close(unit=113)
	  close(unit=115)
	  close(unit=116)

		
       write(*,*)'rejp: ',rejp
	 print *,"rejc",rejc
	 
	
	   END PROGRAM repar2

	   ! #####################################################################
	   ! #  INICIALIZAO DAS VARIVEIS
	   ! #
	   ! #  Comp   : Comprimento da srie temporal
	   ! #  nexpl  : Nmero de covariveis
	   ! #  flagdum: Indicadora da presena de dummies para dia da semana
	   ! #  flagsaz: Indicadora da presena se sazonalidade anual
	   ! #  nregr  : Total de regressoras: covariveis+dummies+sazonais
	   ! #  maxmiss: Nmero mximo de observaes missing
	   ! #
	   ! #####################################################################
	   SUBROUTINE  inicio ()
	   USE variables
	   IMPLICIT NONE
	
        
         dad ='PMrio_700'
	   Comp=670
         nexpl=1
	   nclim=4
	   ndia=7
	   nlag=0 ! nmero de defasagens na regressora
	   comp=comp-nlag
         grav=1 ! # Geraes entre cada gravao
	   flagdum=0 !1, caso haja dummies, 0 caso contrrio
	   flagsaz=1 !1, caso haja sazonalidade, 0 caso contrrio
	   nregr=nexpl+nlag !uma regressora + defasagem
	   maxmiss=150
	   maxmissW=150
	   burning=1 !numero de iteracoes iniciais desprezadas
	   totamost =100000 ! Total de observacoes na amostra dividido por GRAV 
	   cadfinal=10000  !no. de observaes da cadeia final * jump
	   JUMP    = 20      !Salto na corrida para se obter as observacoes aserem
	 				    ! consideradas na analise

                       


         ALLOCATE(missy(maxmiss),missing(maxmiss,2),
     +	   missingW(maxmissW,2))
	   missy=0
	   missing=0
	   missingW=0
	   ALLOCATE(Xt(Comp,nregr),Yt(Comp),soma(nregr),cont(nregr)
     +   ,lamb(Comp),Wt(Comp,nclim),somaW(nclim),contW(nclim))
	   ALLOCATE(idmatb(nregr,nregr),Cbeta(nregr,nregr),mbeta(nregr),
     +	   idmatd(nclim,nclim),Cdelta(nclim,nclim),mdelta(nclim),
     +        Cdeltad(ndia,ndia),mdeltad(ndia),idmatdd(ndia,ndia),
     +        Dt(comp,ndia))

       ! Parametros das Prioris 
!	    Cx (declarado dentro de Met_has e igual a 10000)
	   idmatb=0.0d0
	   do i=1,nregr
	      do j=1,nregr
	         if (i.EQ.j) then 
		        idmatb(i,j)=1.0d0
	         endif
	      end do
	   end do 
	   Cbeta=100000.0d0*idmatb
	   mbeta=0.00d0

	   do i=1,nclim
	      do j=1,nclim
	         if (i.EQ.j) then 
		        idmatd(i,j)=1.0d0
	         endif
	      end do
	   end do 
	   Cdelta=100000.0d0*idmatd
	   mdelta=0.00d0

	   do i=1,ndia
	      do j=1,ndia
	         if (i.EQ.j) then 
		        idmatdd(i,j)=1.0d0
	         endif
	      end do
	   end do 
	   Cdeltad=100000.0d0*idmatdd
	   mdeltad=0.00d0



	   mefp=0.0d0 !mdia a priori de efpol0
	   Cefp=10.0d0 !varincia  apriori de efpol0
 	   mX=-0.6d0 !mdia a priori de x0
	   CX=0.005d0 !varincia  apriori de x0

	   aa=0.00001d0 !parametro de forma da priori de alpha
	   la=0.00001d0 !parametro de escala da priori de alpha


	
	  END SUBROUTINE inicio

	  ! #####################################################################
	  ! #   Lendo o arquivo de dados e montando dummies e sazonalidade 
	  ! #####################################################################

	  SUBROUTINE readdata()
	   USE variables
	   IMPLICIT NONE
     
	   CALL inicio() 
			 	
  !     LENDO O ARQUIVO DE DADOS
  !     ---------------------------
	   
	   imiss=0
	   imissy=0
	   imissW=0
         soma=0
	   somaW=0
	   cont=0
	   contW=0
       
      OPEN(90,FILE=
     +'c:\mariane\doutorado\dados\tese\'//dad//'.txt',STATUS='OLD')
      OPEN(91,FILE='c:\mariane\doutorado\output\tese\gar1s0szb\
     +'//dad//'.out',STATUS='UNKNOWN')
    
  

	   do i=1,Comp
	    READ(90,*) Yt(i),lixo2,(Xt(i,j),j=1,nregr),lixo2,
     +		(Wt(i,k),k=1,(nclim-2)),(Dt(i,l),l=1,ndia)

 	    write(91,92) Yt(i),(Xt(i,j),j=1,nregr),(Wt(i,k),k=1,2)
   92    format(F10.5, F10.5,F10.5,F10.5,F10.5,F10.5,F10.5,F10.5,
     +    F10.5,F10.5,F10.5,F10.5,F10.5,F10.5)
	    if (yt(i) .EQ. 9.99900d0) then 
	       yt(i)=50.0d0
	       imissy=imissy+1
	       missy(imissy)=i
	    endif
	    do j=1,nexpl
	      if (Xt(i,j) .NE. 99.9D0) then
	       soma(j)=soma(j)+Xt(i,j)
             cont(j)=cont(j)+1
	      else
		   imiss=imiss+1
	       missing(imiss,1)=i
	       missing(imiss,2)=j
	      endif
	    end do
	    do k=1,nclim
	        if (Wt(i,k) .NE. 99.9D0) then
	          somaW(k)=somaW(k)+Wt(i,k)
                contW(k)=contW(k)+1
	        else
		      imissW=imissW+1
	          missingW(imissW,1)=i
	          missingW(imissW,2)=k
	        endif
	    end do

	   end do
	  CLOSE(UNIT=90)
	  CLOSE(UNIT=91)

         totmiss=imiss
	   totmissy=imissy
	   totmissw=imissw
!	   write(*,*) imiss,"  ",imissy
!	   pause

 

C	   CRIA DUMMIES PARA DIA DA SEMANA 
!      --------------------------------
!	   if (flagdum.EQ.1) then 
!  	     do i=1,Comp
!	        do j=(nexpl+1),nregr
!	           Xt(i,j)=0.0
!	           if (mod(i,7).NE.0) then 
!	              Xt(i,(nexpl+mod(i,7)))=1.0
!	           end if
!	        end do
!         end do
!	   end if

C	   MONTA SAZONALIDADE ANUAL
!      -------------------------------
	   if (flagsaz.EQ.1) then 
	    do i=1,Comp
	       wt(i,nclim-1)=COS(2*PI*i/365)
	       wt(i,nclim)=SIN(2*PI*i/365)
!	       Xt(i,nregr-1)=COS(4*PI*i/365)
!	       Xt(i,nregr)  =SIN(4*PI*i/365)
	    end do
	   end if

	  OPEN(20,FILE='c:\mariane\doutorado\output\tese\'//DAD//'.txt',
     +    STATUS='UNKNOWN')
	  do i=1,Comp
 	     write(20,21) yt(i),(Xt(i,j),j=1,nregr),(Wt(i,k),k=1,nclim)
  21     format(F6.2,F10.2,F10.2,F10.2,F10.2,F6.2,F6.2,F6.2,
     +          F6.2,F6.2,F6.2,F6.2,F6.2,F6.2,F6.2)
	  end do
	  CLOSE(UNIT=20)

	  END SUBROUTINE readdata
 

	! #####################################################################
	! #                 METROPOLIS-HASTING	
    ! #   Gera uma realizao da distribuio conjunta
	! #####################################################################
	   
	  SUBROUTINE MET_HAS(TGrande,beta,delta,deltad,W1
     +	  ,lamcalc)
	  ! TGrande  o comprimento da srie temporal
	  USE variables
 	  USE PORTLIB

	IMPLICIT NONE								 
      INTEGER, INTENT(IN) :: TGrande
	DOUBLE PRECISION, PARAMETER ::  d1=0.02d0,mmu=0.0d0,
     +  	varefp=0.0005d0,Cm=0.0005d0,varx=0.01d0,varbeta=0.0001d0,
     +vardelta=0.000003d0,varalpha=0.008d0,vardeltad=0.0003d0 
      DOUBLE PRECISION :: mutA,lambda,ytil,Vtil,W1,
     +	   lambdaA,ytilA,VtilA,razao,mm,sum,sumA,
     +       acumyt,funcw(TGrande,nclim),funcx(TGrande,nregr),
     +       funcxA(TGrande,nregr),funcwA(TGrande,nclim),
     +       Cb(nregr,nregr),CbA(nregr,nregr),Cd(nclim,nclim),
     +       CdA(nclim,nclim),detCbA,detCb,detCdA,detCd,
     +       mbA(nregr),mdA(nclim),num,den,CmA,
     +       mb(nregr),md(nclim),mmA,beta(nregr),betaprop(nregr),
     +       lamcalc(Tgrande),delta(nclim),deltaprop(nclim),
     +       vetum(nregr),auxdelta(nclim),auxbeta(nregr),
	+       efclimA(Tgrande),efpolA(TGrande),auxefp,auxefc,
     +       psipropp,u,unif,densnew,densold,auxx,x0prop,auxvet(nregr),
	+	   ran2,psipropc,efpolprop,efclimprop,rhopropp,rhopropc,auxy,
	+       gama,gamaprop,alphaprop,sumln,sumlnA,dgamma,deltad(ndia),
	+       deltadprop(ndia),Cdd(ndia,ndia),CddA(ndia,ndia),mdda(ndia)
     +,mdd(ndia),auxdeltad(ndia)
	DOUBLE PRECISION, DIMENSION(:)   :: 
     +	auxmediab(nregr),auxvb(nregr),auxv2b(nregr),auxmediad(nclim),
	+    auxvd(nclim),auxv2d(nclim),auxvdd(ndia),auxv2dd(ndia),
     +auxmediadd(ndia)

	DOUBLE PRECISION, DIMENSION(:,:) :: 
     +	auxvarb(nregr,nregr),auxmb(nregr,nregr),auxvard(nclim,nclim),
     +    auxmd(nclim,nclim),auxvardd(ndia,ndia)
            
      INTEGER :: t,indbeta,inddelta
	EXTERNAL   DGAMMA


	rejp=0
	rejc=0

! ---------Construo dos efpols----------
 	   funcx(1,:)=xt(1,:)
	   efpol(1)=rhop*efpol0+dot_product(funcx(1,:),beta)
	  	   
	   do t=2, TGrande						
	    funcx(t,:)=rhop*funcx(t-1,:)+xt(t,:)

	  	efpol(t)=(rhop**t)*efpol0+dot_product(funcx(t,:),beta)
       end do


! ---------Construo dos efclims----------
 	  do t=1, TGrande
		efclim(t)=dot_product(wt(t,:),delta)+ 
     +		dot_product(dt(t,:),deltad)
       end do

      


!     -----------------------------
!          Gera alpha
!     -----------------------------
       
	  
	  gama=dlog(alpha)
	  call gnormal(gama,varalpha,gamaprop)
	  alphaprop=dexp(gamaprop)

	  razao=gamaprop-gama !RAZAO DE JACOBIANOS
	     sum=0.0d0
	     sumln=0.0d0
	     do t=1,TGrande
	        lambda=alpha*dexp(-(mut+efpol(t)+efclim(t))) 
			sum=sum+yt(t)*lambda
	        sumln=sumln+dlog(yt(t)*lambda)
	     end do
	     razao=razao+la*(alpha-alphaprop)+(aa-1)*
     +		 (dlog(alphaprop)-dlog(alpha))!razao de prioris
   
           sumA=0.0d0
	     sumlnA=0.0d0
	     do t=1,TGrande
	        lambdaA=alphaprop*dexp(-(mut+efpol(t)+efclim(t)))
	        sumA=sumA+yt(t)*lambdaA
	        sumlnA=sumlnA+dlog(yt(t)*lambdaA)
	     end do

	     razao=razao-sumA+sum+alphaprop*sumlnA-alpha*sumln+
     +		 Tgrande*(dlog(dgamma(alpha))-dlog(dgamma(alphaprop)))	!raz veros.
 		 unif=ran2(sem)
	     if (razao.GE.dlog(unif)) then 
		     alpha=alphaprop
		     acalpha=aCalpha+1.0d0
	     endif

!		write(*,*)'a'
!	   pause


!     -----------
!	  GERA Mu 
!     -----------

 
	     sum=0.0d0
	     do t=1,TGrande
	        lambda=alpha*dexp(-(mut+efpol(t)+efclim(t))) 
			sum=sum+yt(t)*lambda
	     end do
		 call gNormal(mut,Cm,muta)
	     call lndNorm(mmu,W1,muta,num)
	     call lndNorm(mmu,W1,mut,den)

	     razao=num-den
   
           sumA=0.0d0
	     do t=1,TGrande
	        lambdaA=alpha*dexp(-(mutA+efpol(t)+efclim(t)))
	        sumA=sumA+yt(t)*lambdaA
	     end do

	     razao=razao-sumA+sum+alpha*Tgrande*(mut-muta)
 		 unif=ran2(sem)
	     if (razao.GE.dlog(unif)) then 
		     mut=mutA
		     aCm=aCm+1.0d0
	     endif


!	 -------------------
!	  Gera Beta 
!      -------------------
	  indbeta=1
	  razao=0.0d0
    
	  Cb=Cbeta
 	  CALL inverse(nregr,Cb)	
	  mb=matmul(Cb,mbeta)
	  lambda=alpha*dexp(-(mut+efpol(1)+efclim(1)))
	  call modyt(yt(1),alpha,lambda,ytil)
	  call modVt(alpha,lambda,Vtil)
	  auxvet=xt(1,:)
    	  auxvb=auxvet*(ytil-mut-rhop*efpol0-efclim(1))/Vtil
	  mb=mb+auxvb
	  auxvb=(1/Vtil)*auxvet
	 	 CALL vvt(nregr,auxvb,auxvet,auxmb)
		 Cb=Cb+auxmb
	     razao=razao+yt(1)*lambda !razao de veross(parte da post.)
	do t=2,TGrande
	     lambda=alpha*dexp(-(mut+efpol(t)+efclim(t)))
	     call modyt(yt(t),alpha,lambda,ytil)
	     call modVt(alpha,lambda,Vtil)
	     auxvet=xt(t,:)
	     auxvb=(auxvet+rhop*funcx(t-1,:))*(ytil-mut-
     +		 (rhop**t)*efpol0-efclim(t))/Vtil
             mb=mb+auxvb
	     auxvb=(1/Vtil)*(auxvet+rhop*funcx(t-1,:))
	     auxv2b=auxvet+rhop*funcx(t-1,:)
 	     CALL vvt(nregr,auxvb,auxv2b,auxmb)
	     Cb=Cb+auxmb
	     razao=razao+yt(t)*lambda !razao de veross (parte da post.)
	end do
        CALL inverse(nregr,Cb)
	mb=matmul(Cb,mb)
        CALL gNormult(nregr,mb,Cb,betaprop) 

	!aqui
!	betaprop(1)=0.03d0
	CbA=Cbeta
        CALL inverse(nregr,CbA)

        mbA=matmul(CbA,mbeta)

        efpolA(1)=rhop*efpol0+dot_product(funcx(1,:),betaprop)
 	lambdaA=alpha*dexp(-(mut+efpolA(1)+efclim(1)))
	call modyt(yt(1),alpha,lambdaA,ytilA)
       call modVt(alpha,lambdaA,VtilA)
	auxvet=xt(1,:) 	
	auxvb=auxvet*(ytilA-mut-rhop*efpol0-efclim(1))/VtilA
	mbA=mbA+auxvb
        auxvb=(1/VtilA)*auxvet
        CALL vvt(nregr,auxvb,auxvet,auxmb)
        CbA=CbA+auxmb
        razao=razao-yt(1)*lambdaA ! razao de veros(parte da post.)

        do t=2,TGrande  	 	
	     efpolA(t)=(rhop**t)*efpol0+dot_product(funcx(t,:),betaprop)
 	     lambdaA=alpha*dexp(-(mut+efpolA(t)+efclim(t)))
	     call modyt(yt(t),alpha,lambdaA,ytilA)
           call modVt(alpha,lambdaA,VtilA) 
		 auxvet=xt(t,:)	
	     auxvb=(auxvet+rhop*funcx(t-1,:))*(ytilA-mut-
     +		 (rhop**t)*efpol0-efclim(t))/VtilA
 	     mbA=mbA+auxvb
           auxvb=(1/VtilA)*(auxvet+rhop*funcx(t-1,:))
	     auxv2b=auxvet+rhop*funcx(t-1,:)
            CALL vvt(nregr,auxvb,auxv2b,auxmb)
            CbA=CbA+auxmb
            razao=razao-yt(t)*lambdaA
        end do


        CALL inverse(nregr,CbA) 

        mbA=matmul(CbA,mbA)

	    call determ(nregr,CbA,detCbA) 
	    call determ(nregr,Cb,detCb)
        if ((detCbA.LE.0.0d0) .OR. (detCb.LE.0.0d0)) then
           indbeta=0
        else
		 auxmediab=mba
		 auxvarb=CbA
		 auxbeta=beta	  
		 call lndNM(nregr,auxmediab,auxvarb,auxbeta,num)
		 auxmediab=mb 
		 auxvarb=Cb
		 auxbeta=betaprop
	     call lndNM(nregr,auxmediab,auxvarb,auxbeta,den)
	     razao=razao+num-den !razao de propostas
        endif
        mbA=0.0d0
        CbA=Cbeta
	  do t=1,TGrande
           auxvb=funcx(t,:) 
           mbA=mbA+auxvb
        end do
	 auxv2b=beta-betaprop
  	 razao=razao+alpha*dot_product(mba,auxv2b)! razao de veros(parte da post)	
       mbA=mbeta
	 auxmediab=mbA
	 auxvarb=CbA
	 auxbeta=betaprop
	  call lndNM(nregr,auxmediab,auxvarb,auxbeta,num)
	  densnew=densnew+NUM
	  auxmediab=mbA
	  auxvarb=CbA
	  auxbeta=beta
	  call lndNM(nregr,auxmediab,auxvarb,auxbeta,den)
        razao=razao+num-den ! razao de prioris (parte da posteriori)
        unif=ran2(sem)
        if ((dlog(unif).LE. razao) .AND. indbeta.EQ.1) then
	   beta=betaprop
         acb=acb+1.0d0
	   efpol=efpolA
        endif





!	 -------------------
!	  Gera Delta 
!      -------------------
 !	  allocate(auxmedia(nregr),auxvar(nregr,nregr),auxv(nregr),
 !    +	  auxv2(nregr),auxm(nregr,nregr))
	  razao=0.0d0
    

	  do t=1,TGrande
	     lambda=alpha*dexp(-(mut+efpol(t)+efclim(t)))
	     razao=razao+yt(t)*lambda
 	  end do
	  Cd=vardelta*idmatd
        CALL gNormult(nclim,delta,Cd,deltaprop)
	   
      !aqui fixa delta
      !	deltaprop(1)=0.03d0
        do t=1,TGrande  	 	
	     efclimA(t)=dot_product(wt(t,:),deltaprop)+
	+dot_product(dt(t,:),deltad)
 	     lambdaA=alpha*dexp(-(mut+efpol(t)+efclimA(t)))
           razao=razao-yt(t)*lambdaA
        end do
        mdA=0.0d0
        CdA=Cdelta
	  do t=1,TGrande
           auxvd=wt(t,:) 
           mdA=mdA+auxvd
        end do
	  auxv2d=delta-deltaprop
  	  razao=razao+alpha*dot_product(mda,auxv2d)	

       mdA=mdelta
	  auxmediad=mdA
	  auxvard=CdA
	  auxdelta=deltaprop
	  call lndNM(nclim,auxmediad,auxvard,auxdelta,num)
	  densnew=densnew+NUM
	  auxmediad=mdA
	  auxvard=CdA
	  auxdelta=delta
	  call lndNM(nclim,auxmediad,auxvard,auxdelta,den)
        razao=razao+num-den
        unif=ran2(sem)
        if (dlog(unif).LE. razao) then
	   delta=deltaprop
         acd=acd+1.0d0
	   efclim=efclimA
        endif
!	  deallocate(auxmediab,auxvarb,auxvb,auxv2b,auxm)


!	 -------------------
!	  Gera deltadD 
!      -------------------
	  razao=0.0d0
    

	  do t=1,TGrande
	     lambda=alpha*dexp(-(mut+efpol(t)+efclim(t)))
	     razao=razao+yt(t)*lambda
 	  end do
	  Cdd=vardeltad*idmatdd
        CALL gNormult(ndia,deltad,Cdd,deltadprop)
	   
      !aqui fixa deltad
      !	deltadprop(1)=0.03d0
        do t=1,TGrande  	 	
	     efclimA(t)=dot_product(dt(t,:),deltadprop)+
	+dot_product(wt(t,:),delta)
 	     lambdaA=alpha*dexp(-(mut+efpol(t)+efclimA(t)))
           razao=razao-yt(t)*lambdaA
        end do
        mddA=0.0d0
        CddA=Cdeltad
	  do t=1,TGrande
           auxvdd=dt(t,:) 
           mddA=mddA+auxvdd
        end do
	  auxv2dd=deltad-deltadprop
  	  razao=razao+alpha*dot_product(mdda,auxv2dd)	
       mddA=mdeltad
	  auxmediadd=mddA
	  auxvardd=CddA
	  auxdeltad=deltadprop
	  call lndNM(ndia,auxmediadd,auxvardd,auxdeltad,num)

	  densnew=densnew+NUM
	  auxmediadd=mddA
	  auxvardd=CddA
	  auxdeltad=deltad
	  call lndNM(ndia,auxmediadd,auxvardd,auxdeltad,den)
        razao=razao+num-den
        unif=ran2(sem)
        if (dlog(unif).LE. razao) then
	   deltad=deltadprop
         aCdd=aCdd+1.0d0
	   efclim=efclimA
        endif
!	  deallocate(auxmediab,auxvarb,auxvb,auxv2b,auxm)



 
!     -----------------------------		  

!          Gera efpol0
!     -----------------------------
	   razao=0.0d0
	   auxefp=0.0d0
	   do t=1,TGrande
	        lambda=alpha*dexp(-(mut+efpol(t)+efclim(t)))
			razao=razao+yt(t)*lambda
	   end do
	   call gnormal(efpol0,varefp,efpolprop)
	!aqui fixa efpol
!	   efpolprop=efpol0

	   do t=1,TGrande
 		    efpolA(t)=(rhop**t)*efpolprop+dot_product(funcx(t,:),beta)
			lambdaA=alpha*dexp(-(mut+efpolA(t)+efclim(t)))
	        razao=razao-yt(t)*lambdaA
	        auxefp=auxefp+rhop**t
	   end do
	   call lndNorm(mefp,Cefp,efpolprop,num)
	   call lndNorm(mefp,Cefp,efpol0,den)
	   razao=razao + alpha*(efpol0-efpolprop)*auxefp+num-den

	   u=ran2(sem)
	   if (dlog(u).LE.razao) then
	      acefp=acefp+1.0d0 
	      efpol0=efpolprop
	      efpol=efpolA
	   endif



! !     -----------------------------		  
!!          Gera X0
!!     -----------------------------
!!	   razao=0.0d0
!!	   auxx=0.0d0
 !	   do t=1,TGrande
!	        lambda=mut+efpol(t)+efclim(t)
!!			razao=razao+dexp(lambda)
!!	   end do
!!	   call gnormal(x0,varx,x0prop)
!!	   funcxA(1,:)=xt(1,1)
!!	   funcxA(1,2)=x0prop
!!	   efpolA(1)=rhop*efpol0+dot_product(funcxA(1,:),beta)
!!	   lambdaA=mut+efpolA(1)+efclim(1)
!!	   razao=razao-dexp(lambdaA)
!!       auxx=auxx+yt(1)
!	   do t=2, TGrande						
!	      funcxA(t,1)=rhop*funcxA(t-1,1)+xt(t,1)
!	      funcxA(t,2)=rhop*funcxA(t-1,2)+xt(t-1,1)
!	      efpolA(t)=(rhop**t)*efpol0+dot_product(funcxA(t,:),beta)
!	      lambdaA=mut+efpolA(t)+efclim(t)
!	      razao=razao-dexp(lambdaA)
!	      auxx=auxx+yt(t)*rhop**(t-1)
!       end do
!	   call lndNorm(mX,CX,x0prop,num)
!	   call lndNorm(mX,CX,x0,den)
!	   razao=razao + (x0prop-x0)*beta(2)*auxx+ num-den
!
!	   u=ran2(sem)
!	   if (dlog(u).LE.razao) then
!	      acx0=acx0+1.0d0 
!	      x0=x0prop
!	      funcx=funcxA
!	      efpol=efpolA
!	   endif
!
!
!
!     -----------------------------
!          Gera rhop
!     -----------------------------
       
	  
	  psip=dlog(rhop/(1-rhop))
2000	  call gnormal(psip,d1,psipropp)
	  rhopropp=dexp(psipropp)/(1+dexp(psipropp))
        if (rhopropp.EQ.1.0d0) then
	      rejp=rejp+1
	      goto 2000
	  endif 

	!aqui fixa rho
!	 rhopropp=rhop

	  razao=psipropp-2*dlog(1+dexp(psipropp))-psip+
     +	  2*dlog(1+dexp(psip)) !RAZAO DE JACOBIANOS
	  funcxA(1,:)=xt(1,:)

	    efpolA(1)=rhopropp*efpol0+dot_product(funcxA(1,:),beta)
	    lambdaA=alpha*dexp(-(mut+efpolA(1)+efclim(1)))
	    lambda=alpha*dexp(-(mut+efpol(1)+efclim(1)))
 	    razao=razao+yt(1)*lambda-yt(1)*lambdaA+
     +		alpha*(efpol(1)-efpolA(1))
	   do t=2, TGrande
	    funcxA(t,:)=rhopropp*funcxA(t-1,:)+xt(t,:)
	  	efpolA(t)=(rhopropp**t)*efpol0+dot_product(funcxA(t,:),beta)
 	    lambdaA=alpha*dexp(-(mut+efpolA(t)+efclim(t)))
	    lambda=alpha*dexp(-(mut+efpol(t)+efclim(t)))
		razao=razao+yt(t)*lambda-yt(t)*lambdaA+
     +		alpha*(efpol(t)-efpolA(t))
       end do
	  
	   u=ran2(sem)
	   if (dlog(u).LE.razao) then
 	      acrp=acrp+1.0d0
	      rhop=rhopropp
	      funcx=funcxA
	      efpol=efpolA
	   endif
	  
!!     -------------------------------
!	  GERA Y(t) QUANDO MISSING
!     -------------------------------
   
	  do t=1,totmissy
	  lambda=alpha*dexp(-(mut+efpol(missy(t))+efclim(missy(t))))
   		call gGamma(alpha,lambda,auxy)
		yt(missy(t))=auxy
	  end do


 
	  do t=1,Tgrande
	   lamcalc(t)=dexp((mut+ efpol(t)+efclim(t)))! mdia(alpha/lambda) 
	  end do




	  RETURN 
      END SUBROUTINE MET_HAS




	! #########################################################
	! #                                                       #
	! #  Este modulo contem todas as  rotinas                 #
	! #  que so utilizadas ao longo do programa              #
	! #                                                       #
	! #########################################################


	   SUBROUTINE modyt (y,alpha,lambda,mody)
	   IMPLICIT NONE
	   DOUBLE PRECISION :: y,alpha,lambda,mody
          mody=dlog(alpha/lambda)+y*lambda/alpha-1.0d0
	    return
         END 

	  SUBROUTINE modVt (alpha,lambda,modV)
	   IMPLICIT NONE
	   DOUBLE PRECISION :: alpha,lambda,modV
	    modV=lambda/alpha
	   return
        END 


	! #########################################################
	! # GERACAO DE QUANTIDADES ALEATORIAS
	! #########################################################


	!Gerao de valores com distribuio U(0,1)
	!
      ! ran2 from 2nd Edn of Numerical Recipes
      !

	  real*8 FUNCTION ran2(ISEED)
	  implicit none
      INTEGER iseed,im1,im2,imm1,ia1,ia2,iq1,iq2,ir1,ir2,ntab,ndiv
      REAL*8 am,eps,rnmx
      PARAMETER(im1=2147483563,im2=2147483399,am=1./im1,imm1=im1-1,
     +   ia1=40014,ia2=40692,iq1=53668,iq2=52774,ir1=12211,
     +   ir2=3791,ntab=32,ndiv=1+imm1/ntab,eps=1.2e-7,rnmx=1.-eps)
      INTEGER idum2,j,k,iv(ntab),iy
!
      SAVE IV,IY,IDUM2
!
      DATA idum2/123456789/,iv/ntab*0/,iy/0/
      IF (iseed.LE.0) THEN
         iseed=MAX(-iseed,1)
         idum2=iseed
         DO j=ntab+8,1,-1
            k=iseed/iq1
            iseed=ia1*(iseed-k*iq1)-k*ir1
            IF (iseed.LT.0) iseed=iseed+im1
            IF (j.LE.ntab) iv(j)=iseed
         ENDDO
         iy=iv(1)
      ENDIF
      k=iseed/iq1
      iseed=ia1*(iseed-k*iq1)-k*ir1
      IF (iseed.LT.0) iseed=iseed+im1
      k=idum2/iq2
      idum2=ia2*(idum2-k*iq2)-k*ir2
      IF (idum2.LT.0) idum2=idum2+im2
      j=1+iy/ndiv
      iy=iv(j)-idum2
      iv(j)=iseed
      IF (iy.LT.1) iy=iy+imm1
      ran2=MIN(am*iy,rnmx)

      RETURN
      END



	! Gera valores com distribuio Poisson(lambda)
	! Algoritmo em Ross, 1997, p.64
	SUBROUTINE gPoisson(lambda,gpois)
	IMPLICIT NONE
	DOUBLE PRECISION, INTENT(IN) :: lambda
	DOUBLE PRECISION :: prod,z,aux
	INTEGER :: cont,gpois
	REAL    :: unif

	if (lambda .LE. 50) then 
      cont=0
	  prod=1.0d0
      do while (prod.GE.dexp(-lambda))
	  call random(unif)
      prod=prod*unif
	  cont=cont+1
	  end do
  	  gpois=cont-1
	else  !aproximao normal p/ lambda grande (v. Rubinstein)
	  call gNormal(0.0d0, 1.0d0,z)
!	  write(*,*) 'gerou z'
	  aux=lambda+z*sqrt(lambda)-0.5d0
!	  write(*,*) 'calculou aux'
	  gpois=max(0,nint(aux))
!	  write(*,*) 'calculou max'
	endif


	return
      END 

 	  ! Gera valores com distribuio Normal(lambda)
	  ! Algoritmo em 
 	SUBROUTINE gNormal(media,vari,geranorm)
	use variables
       IMPLICIT REAL*8 (A-H,O-Z)
	   DOUBLE PRECISION  :: media, vari,pad,theta
	   u0=ran2(sem)
	   u1=ran2(sem)
46	   if (u1.EQ.0.0d0) then 
	     goto 46
	   endif	  
	   theta=2.0d0*pi*u0
	   e=-dlog(u1)
	   r=dsqrt(2*e)
	   pad=r*dcos(theta)
	   geranorm=media+pad*dsqrt(vari)

       return
       end


    	! Gera valores com distribuio Normal Multivariada(mu,sig)
	    SUBROUTINE gNormult( dim,mu, sig,sai)
        IMPLICIT NONE
        INTEGER :: dim,i   
        DOUBLE PRECISION :: mu(dim),sig(dim,dim),sai(dim),Z(dim),
     +                      S(dim,dim)
          
   	      Z=0.0d0
            do i=1,dim
               call gnormal(0.0d0,1.0d0,Z(i))
            end do
            CALL cholesky(sig,S,dim)
            S=transpose(S)
            sai=matmul(S,Z)
            sai=mu+sai
           END SUBROUTINE gNormult

	 subroutine gExpo(p1,geraexp)
	 use variables
       IMPLICIT REAL*8 (A-H,O-Z)
	    
45	   u0=ran2(sem)
	   if (u0.EQ.1.0d0) then 
	    goto 45
	   endif
        
         geraexp=-(1/p1)*dlog(1.0d0-u0)

       return
       end



         ! Gera Gamma 
       SUBROUTINE gGamma(p1,p2,geraxb)
	 use variables
       IMPLICIT REAL*8 (A-H,O-Z)
  
	   if (dmod(p1,0.5d0).EQ.0) then   !primeiro caso: 2*alpha  inteiro


	     if (dmod(p1,1.0d0).EQ.0) then !alpha  inteiro
	      qui=0.0
	      do i=1,p1
	         call gExpo(0.5d0,valexp)
		     qui=qui+valexp
		  end do
	      geraxb=qui/(2*p2)     
	     else 			    !alpha no  inteiro (=0.5,1.5,2.5,...)
	      qui=0.0
	      aux=int(p1)
	  	 do i=1,aux
		     call gExpo(0.5d0,valexp)
		     qui=qui+valexp
		     end do
		  call gNormal(0.0d0,1.0d0,valnorm)
		  qui=qui+dexp(2*dlog(dabs(valnorm)))  
		  geraxb=qui/(2*p2)	
          endif   
	               
	   else
         if(p1.LT.1)then   !segundo caso:(2*alpha no inteiro, alpha<1)

5          u0=ran2(sem)
           u1=ran2(sem)
           if(u0.GT.DEXP(1.0d0)/(p1+DEXP(1.0d0))) then
             aux=-DLOG((p1+DEXP(1.0d0))*(1-u0)/(p1*DEXP(1.0d0)))
	       if (u1.GT.DEXP((P1-1)*DLOG(aux))) then 
		       goto 5
	       endif
           else
            aux=DEXP((1.0d0/p1)*DLOG(((p1+DEXP(1.0d0))*u0)/DEXP(1.0d0)))
	      if (u1.GT.DEXP(-aux)) then
	           goto 5
	      endif
           endif
           geraxb=(1.0d0/p2)*aux

         else !terceiro caso:(2*alpha no inteiro, alpha>=1)

	       c1=p1-1
           c2  =(p1-(1/(6*p1)))/c1
           c3=2/c1
           c4=c3+2
           c5=1/(dsqrt(p1))
        
55         u0=ran2(sem)
           u1=ran2(sem)
           if(p1.gt.2.5) then
             u0=u1+c5*(1-(1.86d0*u0))
           endif
           if((u0.LE.0.0d0).OR.(u0.GE.1.0d0)) then
             goto 55
           endif
           ww=(c2*u1)/u0
           if ((c3*u0+ww+(1/ww)).LE.c4) then
            isai=1
           endif
           if ((c3*DLOG(u0)-DLOG(ww)+ww).GE.1) then
            isai=0
           endif
           if (isai.EQ.0) then
             goto 55
           endif
           geraxb=(1.0d0/p2)*c1*ww
	     endif
	   endif
       return
       end



	! #########################################################
	! # AVALIAO DE DENSIDADES
	! #########################################################
	  

      SUBROUTINE lndNorm( media, vari, x,lndNor)
	   IMPLICIT NONE
	   DOUBLE PRECISION :: media, vari,x,lndNor
	   REAL,PARAMETER :: PI=3.141592653589793
         ! Calcula o ln da densidade da Normal(media,vari) no ponto x 
	     lndNor=-1/(2*vari)*(x-media)*(x-media)-0.5*dlog(2*PI*vari)
	   return
	   END 

         SUBROUTINE lndNM( dim,media,vari,x,lndN)
         !Calcula o ln da densidade normal multivariada (media,vari) no ponto x
          IMPLICIT NONE
          INTEGER :: dim   
          DOUBLE PRECISION :: media(dim),vari(dim,dim),x(dim),
     +                        auxm(dim,dim),auxv1(dim),auxv2(dim),aux,
     +	                        lndN,detvari
	    REAL,PARAMETER ::PI=3.141592653589793 
          auxv1=(-1.0)*media
          auxv1=x+auxv1
	    auxm=vari
          CALL inverse(dim,auxm)
          auxv2=matmul(auxm,auxv1)
          aux=(-1.0)*0.5*dim*dlog(2.0d0*PI)-0.5*dot_product(auxv1,auxv2)
	    call determ(dim,vari,detvari)
          lndN=aux-0.5*dlog(detvari)
		  return
         END 

	  
	! #########################################################
	! # OPERAES MATRICIAIS
	! #########################################################

	! escalar vezes matriz 

	   SUBROUTINE evm(e,m,sai)
	    USE variables
	    IMPLICIT NONE
	    DOUBLE PRECISION :: m(nregr,nregr),sai(nregr,nregr),e
                  
	    sai=0.0d0
          do i=1,nregr
	       do j=1,nregr
		      sai(i,j)=e*m(i,j) 
		   end do 
		end do 
	   END SUBROUTINE evm
		      
   	! Faz multiplicacao de vetor transposto por vetor
	   SUBROUTINE  vtv(dim, v1, v2,vtvaux)
	    INTEGER, INTENT(IN) :: dim
	    INTEGER :: i
	    DOUBLE PRECISION :: v1(dim),v2(dim),C,vtvaux

          C=0.0d0
          do i=1,dim
	        C=C+v1(i)*v2(i)
	    end do
	    vtvaux=C
         END 

   	! Faz multiplicacao de vetor por vetor transposto
	   SUBROUTINE vvt( dim,v1,v2,sai)
	    IMPLICIT NONE
          INTEGER, INTENT(IN) :: dim
	    INTEGER :: i, j
	    DOUBLE PRECISION :: v1(dim),v2(dim),sai(dim,dim)

          sai=0.0d0
	    do i=1,dim
	       do j=1,dim
		      sai(i,j)=v1(i)*v2(j)
	       end do
	    end do
	   END SUBROUTINE vvt
	 	
	 ! Inverte matriz(nregr,nregr) 

c	   SUBROUTINE minv(mat,sai)
c	    USE variables
c	    IMPLICIT NONE
c	    DOUBLE PRECISION :: mat(nregr,nregr),sai(nregr,nregr),
c     +                     B(nregr,2*nregr),aux,pivot
c          INTEGER ::  piv
c      
c          do i=1,nregr
c	        do j=1,nregr
c	           B(i,j)=mat(i,j)
c		    end do
c	    end do  
c	    do i=1,nregr
c	       do j=(nregr+1),(2*nregr)
c	          B(i,j)=0
c		   end do
c	    end do 
c	    do i=1,nregr
c	       B(i,(nregr+i))=1.0d0
c	    end do 
c	    do i=1,nregr
c             pivot=B(i,i)
c		   piv=i
c		   if (i.LT.nregr) then 
c		      do k=(i+1),nregr 
c		         if (abs(pivot).LT.abs(B(k,i))) then
c	                 pivot=B(k,i)
c	                 piv=k
c	             endif
c	          end do
c	       endif
c	       if (i.NE.piv) then
c		      do j=1,(2*nregr)
c	             aux=B(i,j)
c			     B(i,j)=B(piv,j)
c			     B(piv,j)=aux
c	          end do
c	       endif
c	       do j=i,(2*nregr)
c		      B(i,j)=B(i,j)/pivot
c	       end do
c	       if (i.LT.nregr) then
c		      do k=(i+1),nregr
c	             aux=B(k,i)
c                   do j=1,(2*nregr)
c	                 B(k,j)=B(k,j)-B(i,j)*aux
c		         end do
c	  	      end do
c 		   endif
c		   if (i.GT.1) then 
c		      do k=1,(i-1)
c                   aux=B(k,i)
c	             do j=i,(2*nregr)
c			        B(k,j)=B(k,j)-B(i,j)*aux
c	             end do
c    	          end do
c	       endif
c	    end do
c    	      
c	    do i=1,nregr
c	       do j=1,nregr
c		      sai(i,j)=B(i,(nregr+j))
c		   end do
c	    end do 
c	   END SUBROUTINE minv
        
       !Faz decomposio de Choleski
c       SUBROUTINE chol( dim,mat, sai)
c	   IMPLICIT NONE
c         INTEGER :: i, j, k,dim
c	   DOUBLE PRECISION :: mat(dim,dim),sai(dim,dim),U(dim,dim),aux
c        
c	   U=0.0d0
c        do i=1,dim
c           aux=0.0d0
c           if (i.GT.1) then 
c              do k=1,(i-1) !VAI DAR PROBLEMA PARA i=1???
c                 aux=aux+(U(k,i))**2
c              end do
c		   endif
c           U(i,i)=(mat(i,i)-aux)**0.5
c           do j=(i+1), dim
c              aux=0.0d0
c              if (i.GT.1) then 
c                 do k=1,(i-1)
c                    aux=aux+U(k,i)*U(k,j)
c                 end do
c			  endif
c              U(i,j)=(mat(i,j)-aux)/U(i,i)
c           end do
c        end do
c        sai=U
c       END SUBROUTINE chol

       SUBROUTINE mt( dim,mat,sai)
       !calcula a transposta da matriz (dim,dim) 
	 USE variables
	 IMPLICIT NONE
       INTEGER  dim
	  DOUBLE PRECISION :: mat(dim,dim),sai(dim,dim)

         sai=0.0d0
         do i=1,nregr
           do j=1, nregr
              sai(j,i)=mat(i,j)
           end do 
         end do
         END SUBROUTINE mt

       SUBROUTINE determ(dim,mat,detaux)
       ! Calcula determinante de matriz(dim,dim)
        IMPLICIT NONE
        INTEGER :: i, j, k,dim,piv
        DOUBLE PRECISION :: mat(dim,dim),aux,pivot,det,detaux
        
        det=1.0d0
        do i=1,dim
           pivot=mat(i,i)
           piv=i
           if (i.LT.dim)then
              do k=(i+1),dim
                 if (abs(pivot).LT.abs(mat(k,i))) then
                    pivot=mat(k,i)
                    piv=k
                 endif
              end do
           endif 
           if (i.NE.piv) then
              det=(-1.0)*det
              do j=1,dim
                 aux=mat(i,j)
                  mat(i,j)=mat(piv,j)
                  mat(piv,j)=aux
              end do
            endif
            do j=i,dim
               mat(i,j)=mat(i,j)/pivot
            end do
            det=det*pivot
            if (i.LT.dim) then 
               do k=(i+1),dim
                 aux=mat(k,i)
                 do j=1,dim
                    mat(k,j)=mat(k,j)-mat(i,j)*aux
                 end do
               end do
	      endif
         end do
         detaux=det
		 return
       END 


 	 	 
   

